SystemOrganization addCategory: #Fuel!
SystemOrganization addCategory: #'Fuel-Clusters'!
SystemOrganization addCategory: #'Fuel-Clusters-Optionals'!
SystemOrganization addCategory: #'Fuel-Collections'!
SystemOrganization addCategory: #'Fuel-Core'!
SystemOrganization addCategory: #'Fuel-Errors'!
SystemOrganization addCategory: #'Fuel-Mappers'!
SystemOrganization addCategory: #'Fuel-Streams'!

!LargeNegativeInteger methodsFor: '*Fuel' stamp: 'MarianoMartinezPeck 6/11/2012 22:46'!
fuelAccept: aGeneralMapper
	^ self >= -2147483648
		ifTrue: [ aGeneralMapper  mapAndTraceByClusterName: self to: FLNegative32SmallIntegerCluster ]
		ifFalse: [ aGeneralMapper visitBytesObject: self]! !

!ByteSymbol class methodsFor: '*Fuel' stamp: 'MartinDias 12/30/2011 10:56'!
materializeFrom: aDecoder

	^ aDecoder nextEncodedString asSymbol! !

!ByteSymbol methodsFor: '*Fuel' stamp: 'MartinDias 3/29/2012 03:05'!
fuelAccept: aGeneralMapper

	^aGeneralMapper visitHookPrimitive: self! !

!ByteSymbol methodsFor: '*Fuel' stamp: 'MartinDias 12/30/2011 10:51'!
serializeOn: anEncoder

	anEncoder encodeString: self! !

!CompiledMethod methodsFor: '*Fuel' stamp: 'MarianoMartinezPeck 12/3/2011 19:39'!
abstractBytecodeMessagesFrom: startpc to: endpc
	"Answer an OrderedCollection of the abstract bytecodes sent in the receiver."
	| scanner abstractBytecodes |
	scanner := InstructionStream new method: self pc: startpc.
	"now collect all the bytecode messages in the block."
	abstractBytecodes := OrderedCollection new.
	[scanner pc <= endpc] whileTrue:
		[[scanner interpretNextInstructionFor: nil]
			on: MessageNotUnderstood
			do: [:ex| abstractBytecodes add: ex message]].
	^abstractBytecodes

	"| m | (m := CompiledMethod >> #abstractBytecodeMessagesFrom:to:) abstractBytecodeMessagesFrom: m initialPC to: m endPC"! !

!CompiledMethod methodsFor: '*Fuel' stamp: 'MartinDias 3/28/2012 16:11'!
bytecodesHash
	"Answer a 16-bit checksum of the bytecodes."

	^ self crc16from: self initialPC to: self endPC! !

!CompiledMethod methodsFor: '*Fuel' stamp: 'MartinDias 3/29/2012 03:05'!
fuelAccept: aGeneralMapper

	^aGeneralMapper visitCompiledMethod: self! !

!CompiledMethod methodsFor: '*Fuel' stamp: 'MartinDias 2/18/2013 19:54'!
fuelPrepare
	"Prepare for Fuel serialization."
	
	self isNamedPrimitive ifTrue: [self literals first at: 4 put: 0].
	
	"When the method is a named primitive, the first literal is an array that works as an argument for the VM. The first and second elements represent the module and the name of the primivite. The third element of the array is ignored, it used to be a session ID. The forth element is the primitive index in a externalPrimitiveTable and it is IMPORTANT to put it in zero, otherwise there can be errors. Putting a zero means that the VM will not try to directly execute the primitive from the table and it will always try to load the module. It is the safer thing to do. For more details, read the method #primitiveExternalCall in VMMaker."! !

!Character class methodsFor: '*Fuel' stamp: 'MartinDias 12/30/2011 10:56'!
materializeFrom: aDecoder

	^self value: aDecoder nextEncodedByte! !

!Character methodsFor: '*Fuel' stamp: 'MartinDias 3/29/2012 03:05'!
fuelAccept: aGeneralMapper

	^aGeneralMapper visitCharacter: self! !

!Character methodsFor: '*Fuel' stamp: 'MartinDias 12/30/2011 10:51'!
serializeOn: anEncoder

	anEncoder encodeByte: value! !

!ByteArray methodsFor: '*Fuel' stamp: 'MartinDias 3/28/2012 16:13'!
crc16from: start to: end
	"Compute a 16 bit cyclic redundancy check on the specified interval."

	| crc |
	crc := 0.
	start to: end do: [:i |
		crc := (crc bitShift: -8) bitXor: (
		 #(	16r0000	16rC0C1	16rC181	16r0140	16rC301	16r03C0	16r0280	16rC241
			16rC601	16r06C0	16r0780	16rC741	16r0500	16rC5C1	16rC481	16r0440
			16rCC01	16r0CC0	16r0D80	16rCD41	16r0F00	16rCFC1	16rCE81	16r0E40
			16r0A00	16rCAC1	16rCB81	16r0B40	16rC901	16r09C0	16r0880	16rC841
			16rD801	16r18C0	16r1980	16rD941	16r1B00	16rDBC1	16rDA81	16r1A40
			16r1E00	16rDEC1	16rDF81	16r1F40	16rDD01	16r1DC0	16r1C80	16rDC41
			16r1400	16rD4C1	16rD581	16r1540	16rD701	16r17C0	16r1680	16rD641
			16rD201	16r12C0	16r1380	16rD341	16r1100	16rD1C1	16rD081	16r1040
			16rF001	16r30C0	16r3180	16rF141	16r3300	16rF3C1	16rF281	16r3240
			16r3600	16rF6C1	16rF781	16r3740	16rF501	16r35C0	16r3480	16rF441
			16r3C00	16rFCC1	16rFD81	16r3D40	16rFF01	16r3FC0	16r3E80	16rFE41
			16rFA01	16r3AC0	16r3B80	16rFB41	16r3900	16rF9C1	16rF881	16r3840
			16r2800	16rE8C1	16rE981	16r2940	16rEB01	16r2BC0	16r2A80	16rEA41
			16rEE01	16r2EC0	16r2F80	16rEF41	16r2D00	16rEDC1	16rEC81	16r2C40
			16rE401	16r24C0	16r2580	16rE541	16r2700	16rE7C1	16rE681	16r2640
			16r2200	16rE2C1	16rE381	16r2340	16rE101	16r21C0	16r2080	16rE041
			16rA001	16r60C0	16r6180	16rA141	16r6300	16rA3C1	16rA281	16r6240
			16r6600	16rA6C1	16rA781	16r6740	16rA501	16r65C0	16r6480	16rA441
			16r6C00	16rACC1	16rAD81	16r6D40	16rAF01	16r6FC0	16r6E80	16rAE41
			16rAA01	16r6AC0	16r6B80	16rAB41	16r6900	16rA9C1	16rA881	16r6840
			16r7800	16rB8C1	16rB981	16r7940	16rBB01	16r7BC0	16r7A80	16rBA41
			16rBE01	16r7EC0	16r7F80	16rBF41	16r7D00	16rBDC1	16rBC81	16r7C40
			16rB401	16r74C0	16r7580	16rB541	16r7700	16rB7C1	16rB681	16r7640
			16r7200	16rB2C1	16rB381	16r7340	16rB101	16r71C0	16r7080	16rB041
			16r5000	16r90C1	16r9181	16r5140	16r9301	16r53C0	16r5280	16r9241
			16r9601	16r56C0	16r5780	16r9741	16r5500	16r95C1	16r9481	16r5440
			16r9C01	16r5CC0	16r5D80	16r9D41	16r5F00	16r9FC1	16r9E81	16r5E40
			16r5A00	16r9AC1	16r9B81	16r5B40	16r9901	16r59C0	16r5880	16r9841
			16r8801	16r48C0	16r4980	16r8941	16r4B00	16r8BC1	16r8A81	16r4A40
			16r4E00	16r8EC1	16r8F81	16r4F40	16r8D01	16r4DC0	16r4C80	16r8C41
			16r4400	16r84C1	16r8581	16r4540	16r8701	16r47C0	16r4680	16r8641
			16r8201	16r42C0	16r4380	16r8341	16r4100	16r81C1	16r8081	16r4040)
			 at: ((crc bitXor: (self byteAt: i)) bitAnd: 16rFF) + 1) ].
	^crc! !

!ByteArray methodsFor: '*Fuel' stamp: 'MartinDias 3/29/2012 03:05'!
fuelAccept: aGeneralMapper

	^aGeneralMapper visitBytesObject: self! !

!Set methodsFor: '*Fuel' stamp: 'MartinDias 9/9/2011 14:46'!
addIfNotPresent: anObject ifPresentDo: aBlock
	"Include anObject as one of the receiver's elements and then value aBlock, but only if there
	is no such element already. Anwser anObject."

	| index |
	index := self scanFor: anObject.
	(array at: index) 
		ifNil: [self atNewIndex: index put: anObject asSetElement]
		ifNotNil: [ aBlock value ].
	^ anObject

	"Sets in Pharo 1.2 can't' contain nil, so this implementation is wrong in that version. This is the right one (in Pharo 1.2):

	| index |
	anObject ifNil: [self error: 'Sets cannot meaningfully contain nil as an element'].
	index := self findElementOrNil: anObject.
	(array at: index) 
		ifNil: [ self atNewIndex: index put: anObject ]
		ifNotNil: [ aBlock value ].
	^ anObject"! !

!Set methodsFor: '*Fuel' stamp: 'MarianoMartinezPeck 7/26/2012 17:42'!
fuelAccept: aGeneralMapper
	"Since we have subclasses of Set that behave differently, we cannot use the visitSimpleCollection: for all of them."
	^ ((self class == Set) or: [ self class == IdentitySet ] ) 
		ifTrue: [ aGeneralMapper visitSimpleCollection: self ]
		ifFalse: [ super fuelAccept: aGeneralMapper ] 
	! !

!Set methodsFor: '*Fuel' stamp: 'MarianoMartinezPeck 7/26/2012 17:42'!
fuelAfterMaterialization

	"Since for Set and IdentitySet we are recreating the collection with #add: (see FLSimpleCollectionCluster) we do not need to rehash"
	^ ((self class == Set) or: [ self class == IdentitySet ] ) 
		ifFalse: [ self rehash ] ! !

Error subclass: #FLError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Errors'!

!FLError commentStamp: '<historical>' prior: 0!
I represent an error produced during Fuel operation.!

FLError subclass: #FLMaterializationError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Errors'!

!FLMaterializationError commentStamp: '<historical>' prior: 0!
I represent an error happened during materialization.!

FLMaterializationError subclass: #FLBadSignature
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Errors'!

!FLBadSignature commentStamp: 'MarianoMartinezPeck 10/23/2011 14:32' prior: 0!
I represent an error produced during materialization when the serialized signature doesn't match the materializer's signature (accessible via FLMaterializer>>signature). A signature is a byte prefix that should prefix a well-serialized stream.!

!FLBadSignature class methodsFor: 'signaling' stamp: 'MartinDias 3/20/2012 12:03'!
signalCurrentSignature: currentSignature streamSignature: streamSignature

	^ self signal: 'Unexpected stream signature ', streamSignature asString, ' where it should be ', currentSignature asString, '.'! !

FLMaterializationError subclass: #FLBadVersion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Errors'!

!FLBadVersion commentStamp: 'MarianoMartinezPeck 10/23/2011 14:33' prior: 0!
I represent an error produced during materialization when the serialized version doesn't match the materializer's version (accessible via FLMaterializer>>version). A version is encoded in 16 bits and is enconded heading the serialized stream, after the signature.!

!FLBadVersion class methodsFor: 'signaling' stamp: 'MartinDias 3/20/2012 12:04'!
signalCurrentVersion: currentVersion streamVersion: streamVersion

	^ self signal: 'Unexpected stream version ', streamVersion asString, ' where it should be ', currentVersion asString, '.'
! !

FLMaterializationError subclass: #FLClassNotFound
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Errors'!

!FLClassNotFound commentStamp: 'MarianoMartinezPeck 10/23/2011 14:34' prior: 0!
I represent an error produced during materialization when a serialized class or trait name doesn't exist.!

!FLClassNotFound class methodsFor: 'signaling' stamp: 'MartinDias 3/20/2012 12:06'!
signalWithName: className
	^ self signal: 'Class named ', className printString, ' not found.'! !

FLMaterializationError subclass: #FLGlobalNotFound
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Errors'!

!FLGlobalNotFound commentStamp: 'MartinDias 12/16/2011 01:16' prior: 0!
I represent an error produced during materialization when a serialized global name doesn't exist (at Smalltalk globals).!

!FLGlobalNotFound class methodsFor: 'signaling' stamp: 'MartinDias 3/20/2012 12:06'!
signalWithName: aName
	^ self signal: 'Global named ', aName printString, ' not found.'! !

!FLMaterializationError class methodsFor: 'signaling' stamp: 'MartinDias 3/20/2012 12:47'!
signal: signalerText

	^ super signal: 'Materialization error. ', signalerText
	! !

FLMaterializationError subclass: #FLMethodChanged
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Errors'!

!FLMethodChanged commentStamp: '<historical>' prior: 0!
I represent an error produced during materialization when is detected a change in the bytecodes of a method serialized as global. 

This error was born when testing the materialization of a BlockClosure defined in a method that changed. The test produced a VM crash.!

!FLMethodChanged class methodsFor: 'signaling' stamp: 'MartinDias 3/20/2012 17:47'!
signalWith: aGlobalName and: aSelector
	^ self signal: 'Method ', aGlobalName, '>>#', aSelector, ' changed its bytecodes.'! !

FLMaterializationError subclass: #FLMethodNotFound
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Errors'!

!FLMethodNotFound commentStamp: 'MartinDias 12/16/2011 01:17' prior: 0!
I represent an error produced during materialization when a serialized method in a class or trait name doesn't exist (at Smalltalk globals).!

!FLMethodNotFound class methodsFor: 'signaling' stamp: 'MartinDias 3/20/2012 17:48'!
signalWith: aGlobalName and: aSelector
	^ self signal: 'Method ', aGlobalName, '>>#', aSelector, ' not found.'! !

FLError subclass: #FLSerializationError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Errors'!

!FLSerializationError commentStamp: '<historical>' prior: 0!
I represent an error happened during serialization.!

FLSerializationError subclass: #FLNotInstalledMethod
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Errors'!

!FLNotInstalledMethod commentStamp: '<historical>' prior: 0!
By default, Fuel serializes methods as globals. I am an error produced during serialization, signaled when trying to serialize a method that is not installed in any class. It is a prevention, because such method is lekely to be absent during materialization. This case may happen when serializing closures that hold references to not installed methods. If the user wants to fully serialize methods, then it needs to install the package FuelMetalevel and create the serializer by using the method #newFull. Example:

 FLSerializer newFull serialize: anObject toFileNamed: 'example'.!

!FLNotInstalledMethod class methodsFor: 'signaling' stamp: 'MarianoMartinezPeck 6/9/2012 23:17'!
signalWithSelector: aSelector
	^ self signal: aSelector asString, ' can not be serialized as global because it is not installed. You need FuelMetalevel to fully serialize methods. See the documentation. '! !

FLSerializationError subclass: #FLNotSerializable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Errors'!

!FLNotSerializable commentStamp: '<historical>' prior: 0!
I represent an error which may happen while tracing in the graph an object that is forbidden of being serialized.!

!FLNotSerializable class methodsFor: 'signaling' stamp: 'MartinDias 5/16/2012 00:39'!
signalWith: anObject

 	self signal: 'Found a forbidden object in the graph: ', anObject printString.! !

FLSerializationError subclass: #FLObjectNotFound
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Errors'!

!FLObjectNotFound commentStamp: '<historical>' prior: 0!
I represent an error which may happen during serialization, when trying to encode on the stream a reference to an object that should be encoded before, but it is not.

This usually happens when the graph changes during serialization. 

Another possible cause is a bug in the analysis step of serialization.!

!FLObjectNotFound class methodsFor: 'signaling' stamp: 'MartinDias 3/20/2012 12:15'!
signalWith: anObject

 	self signal: (
		String streamContents: [ :stream |
			stream << 'Unexpected reference to '.
			stream print: anObject.
			stream << ' in the graph. This usually happens when the graph changes during serialization.'.
			]
	)! !

FLSerializationError subclass: #FLObsolete
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Errors'!

!FLObsolete commentStamp: '<historical>' prior: 0!
I am an error produced during serialization, signaled when trying to serialize an obsolete class as global. It is a prevention, because such class is lekely to be absent during materialization.!

!FLObsolete class methodsFor: 'signaling' stamp: 'MartinDias 3/19/2012 00:02'!
signalWithName: classOrTraitName
	^ self signal: classOrTraitName printString, ' can not be serialized as global because it is obsolete.'! !

!FLSerializationError class methodsFor: 'signaling' stamp: 'MartinDias 3/20/2012 12:47'!
signal: signalerText

	^ super signal: 'Serialization error. ', signalerText
	! !

!TimeStamp methodsFor: '*Fuel' stamp: 'MartinDias 3/29/2012 03:05'!
fuelAccept: aGeneralMapper

	^ aGeneralMapper visitFixedObject: self
! !

!WriteStream methodsFor: '*Fuel' stamp: 'MartinDias 8/13/2011 14:28'!
nextBytesPutAll: aCollection
	"Append the bytes of aCollection to the sequence of bytes accessible 
	by the receiver. Answer aCollection."
 
 	| newEnd |
 	collection class instSpec == aCollection class instSpec ifFalse:
 		[^ super nextPutAll: aCollection ].
 
 	newEnd := position + aCollection size.
 	newEnd > writeLimit ifTrue:
 		[self growTo: newEnd + 10].
 
 	collection replaceFrom: position+1 to: newEnd  with: aCollection startingAt: 1.
 	position := newEnd.
	
	^ aCollection! !

!StandardFileStream methodsFor: '*Fuel' stamp: 'MarianoMartinezPeck 9/6/2011 12:42'!
fuelNextWordsInto: aWordObject
	"This method is the same as nextWordsInto: but the restoreEndianness is only done if needed"
	self next: aWordObject basicSize into: aWordObject startingAt: 1.
	^ aWordObject! !

!StandardFileStream methodsFor: '*Fuel' stamp: 'MarianoMartinezPeck 10/10/2011 12:24'!
nextBytesPutAll: aCollection
	self nextPutAll: aCollection! !

!Behavior methodsFor: '*Fuel' stamp: 'MartinDias 6/13/2011 01:04'!
fuelIgnoredInstanceVariableNames
	"Indicates which variables have to be ignored during serialization."

	^#()! !

!UndefinedObject methodsFor: '*Fuel' stamp: 'MartinDias 3/29/2012 03:05'!
fuelAccept: aGeneralMapper

	^aGeneralMapper visitWellKnownObject: self! !

!Debugger class methodsFor: '*Fuel' stamp: 'EstebanLorenzano 2/18/2013 18:37'!
encodeDebugInformationOn: aSerializer
	| str |
	
	str := String new writeStream. 
	str print: Date today; space; print: Time now.
	aSerializer at: #Timestamp putAdditionalObject: str contents. 
	
	str := String new writeStream. 
	str nextPutAll: 'VM: ';
		nextPutAll: Smalltalk platform platformName asString;
		nextPutAll: ' - ';	
		nextPutAll: Smalltalk platform platformSubtype asString;
		nextPutAll: ' - ';
		nextPutAll: Smalltalk os version asString;
		nextPutAll: ' - ';
		nextPutAll: Smalltalk vm version asString.
	aSerializer at: #VM putAdditionalObject: str contents. 
		
	str := String new writeStream. 
	str nextPutAll: 'Image: ';
		nextPutAll:  SystemVersion current version asString;
		nextPutAll: ' [';
		nextPutAll: Smalltalk lastUpdateString asString;
		nextPutAll: ']'.
	aSerializer at: #Image putAdditionalObject: str contents.! !

!Debugger class methodsFor: '*Fuel' stamp: 'EstebanLorenzano 2/19/2013 11:45'!
serializeTestFailureContext: aContext toFileNamed: aFilename
	| serializer |
	
	serializer := FLSerializer newDefault.
	self encodeDebugInformationOn: serializer. 
	serializer addPostMaterializationAction: [ :materialization | 
		Smalltalk tools debugger
			openContext: materialization root
		   	label: 'External stack'
		   	contents: nil ].
		
	serializer
		" use the sender context, generally the current context is not interesting"
		serialize: aContext
		toFileNamed: aFilename! !

!Debugger methodsFor: '*Fuel' stamp: 'EstebanLorenzano 2/18/2013 18:40'!
serializeStack
	| date fileName |
	"Serialize a portion of the current stack trace using fuel.."
	date := DateAndTime now.
	
	fileName := String streamContents: [ :s|
		s 
			<< 'Debugger-Stack-';
			<< self interruptedContext receiver class theNonMetaClass name;
			<< '-'.
		date printYMDOn: s.
		s 
			<< '-'; print: date hour24; print: date minute; print: date second;
			<< '.fuel'].

	[ self class 
		serializeTestFailureContext: self interruptedContext copyStack		
		toFileNamed: fileName	] 
	on: Error 
	do: [:err| "simply continue..." ].! !

!BlockClosure methodsFor: '*Fuel' stamp: 'MartinDias 3/26/2012 19:21'!
cleanCopy
	"Answer a copy of myself preserving in outerContext just the receiver and method, which are the only needed by a clean block closure."

	^ self shallowCopy
		cleanOuterContext;
		yourself! !

!BlockClosure methodsFor: '*Fuel' stamp: 'MartinDias 3/26/2012 19:22'!
cleanOuterContext
	"Clean my outerContext preserving just the receiver and method, which are the only needed by a clean block closure."

	outerContext := outerContext cleanCopy! !

!BlockClosure methodsFor: '*Fuel' stamp: 'MartinDias 3/29/2012 03:05'!
fuelAccept: aGeneralMapper

	^ self shouldBeSubstitutedByCleanCopy
		ifTrue: [ aGeneralMapper visitSubstitution: self by: self cleanCopy  ]
		ifFalse: [ aGeneralMapper visitVariableObject: self ]! !

!BlockClosure methodsFor: '*Fuel' stamp: 'adas 4/16/2012 16:37'!
shouldBeSubstitutedByCleanCopy
	"The 'self sender isNil not' is just to avoid an infinitive loop for the substitution. As you can see, the copy of this closure has a cleaned outer context (see #cleanOuterContext) and such context has a nil sender (see #cleanCopy)"
	^ self isClean and: [ self sender isNil not ]! !

!PositionableStream methodsFor: '*Fuel' stamp: 'MarianoMartinezPeck 9/6/2011 17:02'!
fuelNextWordsInto: aWordObject 
	"This method is the same as nextWordsInto: but the restoreEndianness is only done if needed"
	| blt pos source byteSize |

	byteSize := aWordObject byteSize.
	"is the test on collection basicSize \\ 4 necessary?"
	
	((self position bitAnd: 3) = 0 and: [ (collection basicSize bitAnd: 3) = 0])
		ifTrue: [source := collection.
			pos := self position.
			self skip: byteSize]
		ifFalse: ["forced to copy it into a buffer"
			source := self next: byteSize.
			pos := 0].

	"Now use BitBlt to copy the bytes to the bitmap."
	blt := (BitBlt current
				toForm: (Form new hackBits: aWordObject))
				sourceForm: (Form new hackBits: source).
	blt combinationRule: Form over. "store"
	blt sourceX: 0;
		 sourceY: pos // 4;
		 height: byteSize // 4;
		 width: 4.
	blt destX: 0;
		 destY: 0.
	blt copyBits.

	^ aWordObject 	
! !

!OrderedCollection methodsFor: '*Fuel' stamp: 'MarianoMartinezPeck 7/26/2012 17:42'!
fuelAccept: aGeneralMapper
	"Since we have subclasses of OrderedCollection that behave differently, we cannot use the visitSimpleCollection: for all of them."
	^ (self class == OrderedCollection ) 
		ifTrue: [ aGeneralMapper visitSimpleCollection: self ]
		ifFalse: [ super fuelAccept: aGeneralMapper ] 
	! !

!Collection methodsFor: '*Fuel' stamp: 'MartinDias 5/19/2011 23:41'!
addIfNotPresent: anObject ifPresentDo: aBlock
	"Include anObject as one of the receiver's elements and then value aBlock, but only if there
	is no such element already. Anwser anObject."

	(self includes: anObject) 
		ifFalse: [ self add: anObject ]
		ifTrue: [ aBlock value ].
	^ anObject! !

Collection subclass: #FLLargeIdentityHashedCollection
	instanceVariableNames: 'tally tallies'
	classVariableNames: 'PermutationMap'
	poolDictionaries: ''
	category: 'Fuel-Collections'!

!FLLargeIdentityHashedCollection commentStamp: '<historical>' prior: 0!
I share behavior for special HashedCollections that are optimized for including a large number of elements.!

FLLargeIdentityHashedCollection subclass: #FLLargeIdentityDictionary
	instanceVariableNames: 'keys values'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Collections'!

!FLLargeIdentityDictionary commentStamp: '<historical>' prior: 0!
I am an IdentityDictionary optimized for including a large number of elements.!

!FLLargeIdentityDictionary methodsFor: 'accessing' stamp: 'ul 12/18/2011 11:21'!
at: key

	| hash |
	(keys at: (hash := key largeIdentityHash + 1)) ifNotNil: [ :keyList | 
		1 to: (tallies at: hash) do: [ :index |
			(keyList at: index) == key ifTrue: [
				^(values at: hash) at: index ] ] ].
	self errorKeyNotFound: key! !

!FLLargeIdentityDictionary methodsFor: 'accessing' stamp: 'ul 12/18/2011 11:22'!
at: key ifAbsent: aBlock

	| hash |
	(keys at: (hash := key largeIdentityHash + 1)) ifNotNil: [ :keyList | 
		1 to: (tallies at: hash) do: [ :index |
			(keyList at: index) == key ifTrue: [
				^(values at: hash) at: index ] ] ].
	^aBlock value! !

!FLLargeIdentityDictionary methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 1/12/2012 18:00'!
at: key ifPresent: presentBlock ifAbsent: absentBlock

	| hash |
	(keys at: (hash := key largeIdentityHash + 1)) ifNotNil: [ :keyList | 
		1 to: (tallies at: hash) do: [ :index |
			(keyList at: index) == key ifTrue: [
				^ presentBlock value: ((values at: hash) at: index) ] ] ].
	^absentBlock value! !

!FLLargeIdentityDictionary methodsFor: 'adding' stamp: 'ul 12/18/2011 11:21'!
at: key put: value

	| hash |
	(keys at: (hash := key largeIdentityHash + 1))
		ifNil: [ 
			keys at: hash put: (Array with: key).
			values at: hash put: (Array with: value).
			tallies at: hash put: 1.
			tally := tally + 1 ]
		ifNotNil: [ :keyList | 
			| newIndex |
			1 to: (tallies at: hash) do: [ :index |
				(keyList at: index) == key ifTrue: [
					^(values at: hash) at: index put: value ] ].
			tally := tally + 1.
			keyList size < (newIndex := (tallies at: hash) + 1)
				ifFalse: [ 
					keyList at: newIndex put: key.
					(values at: hash) at: newIndex put: value ]
				ifTrue: [
					| newList |
					(newList := Array new: keyList size * 2)
						replaceFrom: 1 
						to: keyList size
						with: keyList
						startingAt: 1;
						at: newIndex put: key.
					keys at: hash put: newList.
					(newList := Array new: keyList size * 2)
						replaceFrom: 1 
						to: keyList size
						with: (values at: hash)
						startingAt: 1;
						at: newIndex put: value.
					values at: hash put: newList ].
			tallies at: hash put: newIndex ].
	^value! !

!FLLargeIdentityDictionary methodsFor: 'enumerating' stamp: 'ul 3/24/2010 21:47'!
do: aBlock

	^self valuesDo: aBlock! !

!FLLargeIdentityDictionary methodsFor: 'private' stamp: 'MarianoMartinezPeck 12/20/2011 10:29'!
errorKeyNotFound: aKey

	KeyNotFound signalFor: aKey! !

!FLLargeIdentityDictionary methodsFor: 'testing' stamp: 'MarianoMartinezPekc 1/10/2012 18:57'!
includesKey: key

	| hash |
	^(keys at: (hash := key largeIdentityHash + 1))
		ifNil: [ false ]
		ifNotNil: [ :keyList | 
			key 
				ifNotNil: [ keyList fuelPointsTo: key ]
				ifNil: [
					1 to: (tallies at: hash) do: [ :index |
						(keyList at: index) == key ifTrue: [ ^true ] ].
					false ] ]! !

!FLLargeIdentityDictionary methodsFor: 'initialize-release' stamp: 'ul 12/18/2011 11:31'!
initialize

	super initialize.
	keys := Array new: 4096.
	values := Array new: 4096! !

!FLLargeIdentityDictionary methodsFor: 'accessing' stamp: 'ul 3/24/2010 21:57'!
keys

	^Array new: tally streamContents: [ :stream |
		self keysDo: [ :key | stream nextPut: key ] ]! !

!FLLargeIdentityDictionary methodsFor: 'enumerating' stamp: 'ul 3/24/2010 21:35'!
keysAndValuesDo: aBlock

	tally = 0 ifTrue: [ ^self ].
	1 to: 4096 do: [ :arrayIndex |
		| keyArray valueArray |
		keyArray := keys at: arrayIndex.
		valueArray := values at: arrayIndex.
		1 to: (tallies at: arrayIndex) do: [ :index |
			aBlock
				value: (keyArray at: index)
				value: (valueArray at: index) ] ]! !

!FLLargeIdentityDictionary methodsFor: 'enumerating' stamp: 'ul 3/24/2010 21:45'!
keysDo: aBlock

	tally = 0 ifTrue: [ ^self ].
	1 to: 4096 do: [ :arrayIndex |
		| keyArray |
		keyArray := keys at: arrayIndex.
		1 to: (tallies at: arrayIndex) do: [ :index |
			aBlock value: (keyArray at: index) ] ]! !

!FLLargeIdentityDictionary methodsFor: 'copying' stamp: 'ul 12/18/2011 11:35'!
postCopy

	super postCopy.
	keys := keys copy.
	values := values copy.
	1 to: 4096 do: [ :index |
		(keys at: index) ifNotNil: [ :list |
			keys at: index put: list copy.
			values at: index put: (values at: index) copy ] ]! !

!FLLargeIdentityDictionary methodsFor: 'removing' stamp: 'ul 12/18/2011 11:22'!
removeKey: key ifAbsent: aBlock

	| hash |
	(keys at: (hash := key largeIdentityHash + 1)) ifNotNil: [ :keyList |
		| size |
		1 to: (size := tallies at: hash) do: [ :index |
			(keyList at: index) == key ifTrue: [
				| valueList |
				keyList
					at: index put: (keyList at: size);
					at: size put: nil.
				(valueList := values at: hash)
					at: index put: (valueList at: size);
					at: size put: nil.
				(size := size - 1) < (keyList size // 4) ifTrue: [
					| newList |
					newList := Array new: size * 2.
					newList
						replaceFrom: 1
						to: size
						with: keyList
						startingAt: 1.
					keys at: hash put: newList.
					newList := Array new: size * 2.
					newList
						replaceFrom: 1
						to: size
						with: valueList
						startingAt: 1.
					values at: hash put: newList ].
				tallies at: hash put: size.
				tally := tally - 1.
				^key ] ] ].
	^aBlock value! !

!FLLargeIdentityDictionary methodsFor: 'accessing' stamp: 'ul 3/24/2010 21:57'!
values

	^Array new: tally streamContents: [ :stream |
		self valuesDo: [ :value | stream nextPut: value ] ]! !

!FLLargeIdentityDictionary methodsFor: 'enumerating' stamp: 'ul 3/24/2010 21:46'!
valuesDo: aBlock

	tally = 0 ifTrue: [ ^self ].
	1 to: 4096 do: [ :arrayIndex |
		| valueArray |
		valueArray := values at: arrayIndex.
		1 to: (tallies at: arrayIndex) do: [ :index |
			aBlock value: (valueArray at: index) ] ]! !

!FLLargeIdentityHashedCollection class methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 5/28/2012 01:16'!
initialize

	| rng |
	rng := Random seed: 664399324.
	PermutationMap := (0 to: 4095) asArray shuffleBy: rng! !

!FLLargeIdentityHashedCollection class methodsFor: 'comparing' stamp: 'ul 12/18/2011 11:24'!
permuteHash: anInteger
	"Return an integer between 1 and 4096 when the argument is between 1 and 4096."

	^PermutationMap at: anInteger! !

!FLLargeIdentityHashedCollection methodsFor: 'initialize-release' stamp: 'ul 12/18/2011 11:31'!
initialize

	tally := 0.
	tallies := Array new: 4096 withAll: 0! !

!FLLargeIdentityHashedCollection methodsFor: 'copying' stamp: 'ul 12/18/2011 11:35'!
postCopy

	tallies := tallies copy
! !

!FLLargeIdentityHashedCollection methodsFor: 'accessing' stamp: 'ul 12/18/2011 11:33'!
size

	^tally! !

FLLargeIdentityHashedCollection subclass: #FLLargeIdentitySet
	instanceVariableNames: 'array includesNil'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Collections'!

!FLLargeIdentitySet commentStamp: 'HenrikSperreJohansen 12/16/2011 12:55' prior: 0!
A LargeIdentitySet is an IdentitySet for large collections.
Rather than using linear probing, it takes advantage of the fact that identityHash (on a classic, 32bit VM) 
in Pharo only has 4096 unique values, using a bucket for each of those.
It will still work if hash range changes (ie buckets are chosen mod 4096), 
but the potential gain will be lower the more diverse the hash space is.

With linear probing you risk an array looking like this:
Index:	Hash:
	1	X
	2	X
	3	X
	4	4
	5	5
	6	4
	7	4
	8	7
	9	6
	10	X

While with buckets the same dataset looks:
Index:	Hash:
	1	X
	2	X
	3	X
	4	[4, 4, 4]
	5	5
	6	6
	7	7
	8	X
	9	X
	10	X

So includes: can generally be done faster (also sped up byusing a special primitive), 
and removal of objects does not have to do extensive cleanup if object was part of a chain.!

!FLLargeIdentitySet methodsFor: 'adding' stamp: 'MarianoMartinezPekc 1/10/2012 18:57'!
add: anObject

	| hash |
	anObject ifNil: [ 
		includesNil ifFalse: [
			includesNil := true.
			tally := tally + 1 ].
		^anObject ].
	(array at: (hash := anObject largeIdentityHash + 1))
		ifNil: [ 
			array at: hash put: (Array with: anObject).
			tallies at: hash put: 1.
			tally := tally + 1 ]
		ifNotNil: [ :list | 
			(list fuelPointsTo: anObject) ifFalse: [
				| newIndex |
				tally := tally + 1.
				list size < (newIndex := (tallies at: hash) + 1)
					ifFalse: [ list at: newIndex put: anObject ]
					ifTrue: [
						| newList |
						newList := Array new: list size * 2.
						newList
							replaceFrom: 1 
							to: list size
							with: list
							startingAt: 1;
							at: newIndex put: anObject.
						array at: hash put: newList ].
				tallies at: hash put: newIndex ] ].
	^anObject! !

!FLLargeIdentitySet methodsFor: 'adding' stamp: 'MarianoMartinezPekc 1/10/2012 18:57'!
addIfNotPresent: anObject ifPresentDo: aBlock

	| hash |
	anObject ifNil: [ 
		includesNil ifFalse: [
			includesNil := true.
			tally := tally + 1 ].
		^anObject ].
	(array at: (hash := anObject largeIdentityHash + 1))
		ifNil: [ 
			array at: hash put: (Array with: anObject).
			tallies at: hash put: 1.
			tally := tally + 1 ]
		ifNotNil: [ :list | 
			(list fuelPointsTo: anObject) 
			ifTrue: [ aBlock value]
			ifFalse: [
				| newIndex |
				tally := tally + 1.
				list size < (newIndex := (tallies at: hash) + 1)
					ifFalse: [ list at: newIndex put: anObject ]
					ifTrue: [
						| newList |
						newList := Array new: list size * 2.
						newList
							replaceFrom: 1 
							to: list size
							with: list
							startingAt: 1;
							at: newIndex put: anObject.
						array at: hash put: newList ].
				tallies at: hash put: newIndex ] ].
	^anObject! !

!FLLargeIdentitySet methodsFor: 'enumerating' stamp: 'ul 3/23/2010 08:35'!
do: aBlock

	tally = 0 ifTrue: [ ^self ].
	includesNil ifTrue: [ aBlock value: nil ].
	1 to: 4096 do: [ :arrayIndex |
		| subArray |
		subArray := array at: arrayIndex.
		1 to: (tallies at: arrayIndex) do: [ :index |
			aBlock value: (subArray at: index) ] ]! !

!FLLargeIdentitySet methodsFor: 'testing' stamp: 'MarianoMartinezPekc 1/10/2012 18:57'!
includes: anObject

	anObject ifNil: [ ^includesNil ].
	^(array at: (anObject largeIdentityHash + 1))
		ifNil: [ false ]
		ifNotNil: [ :list | list fuelPointsTo: anObject ]! !

!FLLargeIdentitySet methodsFor: 'initialize-release' stamp: 'ul 12/18/2011 11:31'!
initialize

	super initialize.
	array := Array new: 4096.
	includesNil := false! !

!FLLargeIdentitySet methodsFor: 'copying' stamp: 'ul 12/18/2011 11:35'!
postCopy

	super postCopy.
	array := array copy.
	1 to: 4096 do: [ :index |
		(array at: index) ifNotNil: [ :list |
			array at: index put: list copy ] ]! !

!FLLargeIdentitySet methodsFor: 'removing' stamp: 'MarianoMartinezPekc 1/10/2012 18:57'!
remove: anObject ifAbsent: aBlock

	| list hash size |
	anObject ifNil: [
		includesNil ifTrue: [
			includesNil := false.
			tally := tally - 1.
			^anObject ].
		^aBlock value ].
	list := (array at: (hash := anObject largeIdentityHash + 1)) ifNil: [ ^aBlock value ].
	(list fuelPointsTo: anObject) ifFalse: [ ^aBlock value ].
	1 to: (size := tallies at: hash) do: [ :index |
		(list at: index) == anObject 	ifTrue: [
			list
				at: index put: (list at: size);
				at: size put: nil.
			(size := size - 1) < (list size // 4) ifTrue: [
				| newList |
				newList := Array new: size * 2.
				newList
					replaceFrom: 1
					to: size
					with: list
					startingAt: 1.
				array at: hash put: newList ].
			tallies at: hash put: size.
			tally := tally - 1.
			^anObject ] ].
	^aBlock value! !

!SystemDictionary methodsFor: '*Fuel' stamp: 'MartinDias 3/29/2012 03:05'!
fuelAccept: aGeneralMapper

	^aGeneralMapper visitWellKnownObject: self! !

!Boolean methodsFor: '*Fuel' stamp: 'MartinDias 3/29/2012 03:05'!
fuelAccept: aGeneralMapper

	^aGeneralMapper visitWellKnownObject: self! !

!Rectangle methodsFor: '*Fuel' stamp: 'MarianoMartinezPeck 5/18/2012 22:24'!
fuelAccept: aGeneralMapper
	"Since we can have subclasses of Rectangle, like CharacterBlock that adds new instVars, we cannot use the visitRectangle: for it."
	^ (self class == Rectangle) 
		ifTrue: [ aGeneralMapper visitRectangle: self ]
		ifFalse: [ super fuelAccept: aGeneralMapper   ] 
	
! !

!Trait methodsFor: '*Fuel' stamp: 'MartinDias 3/29/2012 03:05'!
fuelAccept: aGeneralMapper

	^aGeneralMapper visitTrait: self! !

!Float class methodsFor: '*Fuel' stamp: 'MartinDias 12/30/2011 11:00'!
materializeFrom: aDecoder

	^ (self new: 2)
		at: 1 put: aDecoder nextEncodedUint32;
		at: 2 put: aDecoder nextEncodedUint32;
		yourself.
! !

!Float methodsFor: '*Fuel' stamp: 'MartinDias 3/29/2012 03:05'!
fuelAccept: aGeneralMapper

	^aGeneralMapper visitHookPrimitive: self! !

!Float methodsFor: '*Fuel' stamp: 'MartinDias 12/30/2011 10:55'!
serializeOn: anEncoder

	anEncoder 
		encodeUint32: (self at: 1);
		encodeUint32: (self at: 2).! !

!Metaclass methodsFor: '*Fuel' stamp: 'MartinDias 3/29/2012 03:05'!
fuelAccept: aGeneralMapper

	^aGeneralMapper visitMetaclass: self
! !

!ContextPart class methodsFor: '*Fuel' stamp: 'MarianoMartinezPeck 5/22/2011 23:44'!
newFromFrameSize: aFrameSize
	
	^ super basicNew: aFrameSize! !

Stream subclass: #FLBufferedWriteStream
	instanceVariableNames: 'stream buffer position streamRespondsToNextPutAllStartingAt'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Streams'!

!FLBufferedWriteStream commentStamp: 'MarianoMartinezPeck 6/5/2011 12:41' prior: 0!
FLBufferedWriteStream is a buffered write stream we use for Fuel serialization. Instead of directly using the stream provided to FLSerializer at creation time by the user, we create an instance of FLBufferedWriteStream for that stream.

MultiByteFileStream has no real buffer and goes to disk too frequently. With FLBufferedWriteStream we keep stuff in a cache and only go to disk when this is full.

The way of using it is jut FLBufferedWriteStream on: aWriteStream. For example:

FLBufferedWriteStream on: (FileDirectory default forceNewFileNamed:  'TestFile') binary

With the message #sizeBuffer: you can set the size of the buffer.

Make sure to always send #flush or #close when you're done, otherwise the last buffer might not yet have been written.
!

!FLBufferedWriteStream class methodsFor: 'accessing' stamp: 'MartinDias 1/6/2012 19:28'!
defaultBufferSize 
	^ 4096! !

!FLBufferedWriteStream class methodsFor: 'instance creation' stamp: 'MartinDias 1/6/2012 19:27'!
on: writeStream 

	^ self on: writeStream bufferSize: self defaultBufferSize! !

!FLBufferedWriteStream class methodsFor: 'instance creation' stamp: 'MartinDias 1/6/2012 19:14'!
on: writeStream bufferSize: aSize
	^ self basicNew
		initializeOn: writeStream 
		bufferSize: aSize;
		yourself! !

!FLBufferedWriteStream methodsFor: 'private' stamp: 'MarianoMartinezPeck 8/17/2012 12:10'!
buffer
	buffer ifNil: [ self sizeBuffer: self defaultBufferSize ].
	^ buffer! !

!FLBufferedWriteStream methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 9/23/2011 22:34'!
bufferFreeSize
	^ buffer size - position! !

!FLBufferedWriteStream methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 5/17/2011 23:32'!
close
	self flushBuffer.
	stream close! !

!FLBufferedWriteStream methodsFor: 'private' stamp: 'MarianoMartinezPeck 9/8/2011 15:35'!
copyWordObjectToBuffer: aWordObject

	| blt |
	
	blt := (BitBlt current
				toForm: (Form new hackBits: self buffer))
				sourceForm: (Form new hackBits: aWordObject).
	blt combinationRule: Form over. "store"
	blt sourceX: 0;
		 sourceY: 0;
		 height: aWordObject byteSize // 4;
		 width: 4.
	blt destX: 0;
		 destY:  position // 4 .
	blt copyBits.

! !

!FLBufferedWriteStream methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 5/17/2011 23:32'!
defaultBufferSize
	^ 8192 "2 raisedTo: 13  "
	

! !

!FLBufferedWriteStream methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 5/17/2011 23:32'!
flush
	self flushBuffer.
	stream flush! !

!FLBufferedWriteStream methodsFor: 'private' stamp: 'MarianoMartinezPeck 10/22/2011 12:46'!
flushBuffer
	position = 0 ifTrue: [ ^ self ].
	position = buffer size
		ifTrue: [
			stream nextPutAll: buffer ]
		ifFalse: [
			streamRespondsToNextPutAllStartingAt
				ifTrue: [ stream next: position putAll: buffer startingAt: 1 ]
				ifFalse: [ stream nextPutAll: (buffer copyFrom: 1 to: position) ] ].
	position := 0! !

!FLBufferedWriteStream methodsFor: 'private' stamp: 'MarianoMartinezPeck 9/23/2011 22:35'!
flushBufferIfFull
	position = buffer size 
		ifTrue: [ self flushBuffer ]
! !

!FLBufferedWriteStream methodsFor: 'initialize-release' stamp: 'MartinDias 1/6/2012 18:06'!
initializeOn: writeStream bufferSize: aSize

	self initialize.
	self initializeStream: writeStream.
	self sizeBuffer: aSize.
	position := 0.! !

!FLBufferedWriteStream methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 10/22/2011 12:46'!
initializeStream: aWriteStream
	stream := aWriteStream.
	"This is ugly, but it is an optimization for #flushBuffer"
	streamRespondsToNextPutAllStartingAt := (stream respondsTo: #next:putAll:startingAt:).! !

!FLBufferedWriteStream methodsFor: 'writing' stamp: 'MarianoMartinezPeck 10/9/2011 22:47'!
nextBytesPutAll: collection
	self flushBufferIfFull.
	collection size <= self bufferFreeSize
		ifTrue: [
			self buffer replaceFrom: position + 1 to: position + collection size with: collection.
			position := position + collection size ]
		ifFalse: [
			self flushBuffer.
			collection size > (self buffer size / 2)
				ifTrue: [ stream nextBytesPutAll: collection ]
				ifFalse: [ self nextBytesPutAll: collection ] ]
! !

!FLBufferedWriteStream methodsFor: 'writing' stamp: 'MarianoMartinezPeck 8/16/2012 13:47'!
nextPut: object
	self flushBufferIfFull.
	position := position + 1.
	self buffer at: position put: object ! !

!FLBufferedWriteStream methodsFor: 'writing' stamp: 'MarianoMartinezPeck 4/23/2012 16:02'!
nextPutAll: collection
	self flushBufferIfFull.
	collection size <= self bufferFreeSize
		ifTrue: [
			self buffer replaceFrom: position + 1 to: position + collection size with: collection.
			position := position + collection size ]
		ifFalse: [
			self flushBuffer.
			collection size > (self buffer size / 2)
				ifTrue: [ stream nextPutAll: collection ]
				ifFalse: [ self nextPutAll: collection ] ]
! !

!FLBufferedWriteStream methodsFor: 'writing' stamp: 'MartinDias 1/11/2012 00:21'!
nextWordsPut: aWordObject
	| byteSize |

	byteSize := aWordObject byteSize.

	"Ensure we are at bigger than the words added, with size next power-of-two"
	byteSize > buffer size ifTrue: [ self sizeBuffer: 1 << (byteSize highBit)].
	
	"BitBlt needs word-aligned access of object. Flushing the buffer is a very good idea because after the position will be zero, which is word aligned.  Word objects always have a full number of words of data to write. (otherwise they'd be variableByte objects or something :P) So as long as the size you write per instance also takes N words, the position will always be aligned (except when writing the first object of a cluster) . After that, we flush when an object larger than current buffer is encountered (statistically rare), or if the buffer is full (which we do anyways).
	Finally, we also need enough free space in the buffer"
	((position bitAnd: 3) = 0 and: [byteSize < self bufferFreeSize])
      	ifFalse: [self flushBuffer].

	self copyWordObjectToBuffer: aWordObject.
	position := position +  byteSize.! !

!FLBufferedWriteStream methodsFor: 'accessing' stamp: 'MartinDias 5/11/2012 20:40'!
position
	^ position + stream position! !

!FLBufferedWriteStream methodsFor: 'printing' stamp: 'MarianoMartinezPeck 5/17/2011 23:32'!
printOn: aStream
	aStream 
		nextPutAll: 'a '; 
		nextPutAll: self class name! !

!FLBufferedWriteStream methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 8/16/2012 12:41'!
sizeBuffer: size
    buffer ifNotNil: [self flushBuffer].
    buffer := (stream isBinary ifTrue: [ ByteArray ] ifFalse: [ String ]) new: size
! !

!Stream methodsFor: '*Fuel' stamp: 'MartinDias 8/13/2011 14:29'!
nextBytesPutAll: aCollection
	"Append the bytes of aCollection to the sequence of bytes accessible 
	by the receiver. Answer aCollection."

	^self nextPutAll: aCollection! !

!ClassTrait methodsFor: '*Fuel' stamp: 'MartinDias 3/29/2012 03:05'!
fuelAccept: aGeneralMapper

	^aGeneralMapper visitClassTrait: self
! !

!Array methodsFor: '*Fuel' stamp: 'MartinDias 3/29/2012 03:12'!
fuelAccept: aGeneralMapper
	
	"This IF is because there are subclasses of Array that are weak. If we do not put this IF, all subclasses fuel be using the #visitVariableObject:, loosing the capability of the weak
	However, this method is just to optimize the method lookup of the message #fuelAccept:. If this method is removed, the default behavior of Object shuld work as well. If the performance is not that different, then we can remove this method which has an ugly if."
	^ self class isWeak
		ifTrue: [ aGeneralMapper visitWeakObject: self ]
		ifFalse: [ aGeneralMapper visitVariableObject: self ]
	
	! !

!MethodContext methodsFor: '*Fuel' stamp: 'MartinDias 3/26/2012 19:17'!
cleanCopy 

	^ self class 
		sender: nil 
		receiver: receiver 
		method: method
		arguments: #()! !

!MethodContext methodsFor: '*Fuel' stamp: 'MartinDias 3/29/2012 03:05'!
fuelAccept: aGeneralMapper

	^aGeneralMapper visitMethodContext: self! !

!Time class methodsFor: '*Fuel' stamp: 'MarianoMartinezPeck 6/9/2012 14:38'!
materializeFrom: aDecoder
	
	^ self 
		seconds: aDecoder nextEncodedUint24
		nanoSeconds: aDecoder nextEncodedUint32! !

!Time methodsFor: '*Fuel' stamp: 'MartinDias 3/29/2012 03:05'!
fuelAccept: aGeneralMapper

	^ aGeneralMapper visitHookPrimitive: self
! !

!Time methodsFor: '*Fuel' stamp: 'MarianoMartinezPeck 6/9/2012 14:27'!
serializeOn: anEncoder

	anEncoder 
		encodeUint24: self asSeconds;
		encodeUint32: self nanoSecond.
		! !

!SmallInteger methodsFor: '*Fuel' stamp: 'MartinDias 3/29/2012 03:05'!
fuelAccept: aGeneralMapper

	^aGeneralMapper visitSmallInteger: self! !

!SmallInteger methodsFor: '*Fuel-Collections' stamp: 'MarianoMartinezPeck 4/20/2012 23:30'!
largeIdentityHash
	"Return an integer between 0 and 4095 based on all of my bits. Make sure that for nearby receivers the result will not be nearby with high probability."

	| remainder hash |
	self >= 0 
		ifTrue: [
			remainder := self.
			hash := 0 ]
		ifFalse: [
			remainder := 0 - self.
			hash := 4095 ].
	[ 
		hash := hash bitXor: (remainder bitAnd: 4095).
		(remainder := remainder bitShift: -12) = 0 ] whileFalse.
	^FLLargeIdentityHashedCollection permuteHash: hash + 1! !

!Date class methodsFor: '*Fuel' stamp: 'MartinDias 2/18/2013 19:19'!
materializeFrom: aDecoder
	^ self 
		starting: (DateAndTime julianDayNumber: aDecoder nextEncodedInt32 offset: ((Duration 
			seconds: aDecoder nextEncodedInt24 
			nanoSeconds: aDecoder nextEncodedInt32)) ) midnight 
		duration: (Duration days: 1)! !

!Date methodsFor: '*Fuel' stamp: 'MartinDias 3/29/2012 03:05'!
fuelAccept: aGeneralMapper

	^ aGeneralMapper visitHookPrimitive: self
! !

!Date methodsFor: '*Fuel' stamp: 'MartinDias 2/18/2013 19:19'!
serializeOn: anEncoder
	anEncoder 
		encodeInt32: start julianDayNumberUTC;
		encodeInt24: start offset asSeconds;
		encodeInt32: start offset nanoSeconds.! !

!HashedCollection methodsFor: '*Fuel' stamp: 'MartinDias 6/13/2011 02:43'!
fuelAfterMaterialization

	self rehash! !

!Point methodsFor: '*Fuel' stamp: 'MartinDias 3/29/2012 03:05'!
fuelAccept: aGeneralMapper

	^ aGeneralMapper visitPoint: self
! !

!DateAndTime class methodsFor: '*Fuel' stamp: 'MarianoMartinezPeck 6/9/2012 20:01'!
materializeFrom: aDecoder

	^ self basicNew
		fuelSet: aDecoder nextEncodedUint32
		nanoSecond: aDecoder nextEncodedUint32
		seconds: aDecoder nextEncodedUint24
		offset: (Duration 
			seconds: aDecoder nextEncodedInt24 
			nanoSeconds: aDecoder nextEncodedInt32);
		yourself.! !

!DateAndTime methodsFor: '*Fuel' stamp: 'MartinDias 3/29/2012 03:05'!
fuelAccept: aGeneralMapper

	^ aGeneralMapper visitHookPrimitive: self
! !

!DateAndTime methodsFor: '*Fuel' stamp: 'MarianoMartinezPeck 7/22/2012 23:28'!
fuelSet: julianDay nanoSecond: nanoSeconds seconds: numberOfSeconds offset: anOffset
	julianDayNumber := julianDay.
	nanos := nanoSeconds.
	seconds := numberOfSeconds.
	offset := anOffset.! !

!DateAndTime methodsFor: '*Fuel' stamp: 'MarianoMartinezPeck 7/22/2012 23:30'!
serializeOn: anEncoder

	anEncoder 
		encodeUint32: self julianDayNumberUTC;
		encodeUint32: self nanoSecond;
		encodeUint24: self secondsSinceMidnight;
		encodeInt24: self offset asSeconds;
		encodeInt32: self offset nanoSeconds.! !

!ProtoObject methodsFor: '*Fuel-Collections' stamp: 'MarianoMartinezPekc 1/10/2012 18:56'!
fuelPointsTo: anObject
	"This method returns true if self contains a pointer to anObject,
		and returns false otherwise"
	<primitive: 132>
	"This is the same as the following smalltalk code:
	1 to: self class instSize do:
		[:i | (self instVarAt: i) == anObject ifTrue: [^ true]].
	1 to: self basicSize do:
		[:i | (self basicAt: i) == anObject ifTrue: [^ true]].
	^ false"
! !

!ProtoObject methodsFor: '*Fuel-Collections' stamp: 'ul 12/18/2011 11:14'!
largeIdentityHash

	<primitive: 75>
	self primitiveFailed! !

!LargePositiveInteger methodsFor: '*Fuel' stamp: 'MarianoMartinezPeck 6/11/2012 22:47'!
fuelAccept: aGeneralMapper
	^ self <= 4294967295 
		ifTrue: [ aGeneralMapper  mapAndTraceByClusterName: self to: FLPositive32SmallIntegerCluster ]
		ifFalse: [ aGeneralMapper visitBytesObject: self]! !

!Dictionary methodsFor: '*Fuel' stamp: 'MarianoMartinezPeck 7/30/2012 23:16'!
fuelAccept: aGeneralMapper
	| class |
	"Since we have subclasses of Dictionary that behave differently, we cannot use the visitDictionary: for all of them.	 We could also use MethodDictionary for this case, but its materialization is much slower with this cluster than with the default action."
	class := self class.
	^ (((class == Dictionary) or: [class == IdentityDictionary ])) 
		ifTrue: [ aGeneralMapper visitDictionary: self ]
		ifFalse: [ super fuelAccept: aGeneralMapper ] 
	! !

!Dictionary methodsFor: '*Fuel' stamp: 'MarianoMartinezPeck 7/30/2012 23:15'!
fuelAfterMaterialization
	| class |
	"Since for Set and IdentitySet we are recreating the collection with #add: we do not need to rehash."
	class := self class.
	^ (((class == Dictionary) or: [ class == IdentityDictionary ]) ) 
		ifFalse: [ self rehash ] ! !

!ByteString class methodsFor: '*Fuel' stamp: 'MartinDias 12/30/2011 10:56'!
materializeFrom: aDecoder

	^ aDecoder nextEncodedString! !

!ByteString methodsFor: '*Fuel' stamp: 'MartinDias 3/29/2012 03:05'!
fuelAccept: aGeneralMapper

	^aGeneralMapper visitHookPrimitive: self! !

!ByteString methodsFor: '*Fuel' stamp: 'MartinDias 12/30/2011 10:50'!
serializeOn: anEncoder

	anEncoder encodeString: self! !

!ClassDescription methodsFor: '*Fuel' stamp: 'MartinDias 12/22/2011 15:24'!
instanceVariableNamesDo: anUnaryBlock
	"This is part of the interface between the compiler and a class's instance or field names.
	 The class should enumerate anUnaryBlock with the instance variable name strings.  The order is important. Names evaluated later will override the
	 same names occurring earlier."

	| superInstSize |
	(superInstSize := superclass notNil ifTrue: [superclass instSize] ifFalse: [0]) > 0 ifTrue:
		[superclass instanceVariableNamesDo: anUnaryBlock].
	1 to: self instSize - superInstSize do:
		[:i| anUnaryBlock value: (instanceVariables at: i)]! !

!Class methodsFor: '*Fuel' stamp: 'MartinDias 3/29/2012 03:05'!
fuelAccept: aGeneralMapper

	^aGeneralMapper visitClass: self! !

Object subclass: #FLAnalysis
	instanceVariableNames: 'objectStack firstMapper clusterization root privateObjectStack privateFirstMapper'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core'!

!FLAnalysis commentStamp: 'MartinDias 8/29/2011 19:15' prior: 0!
I am responsible of traversing the graph of references starting from a root object. I will produce a clusterization which the serializer will store on a stream.

An example of use is:

	(FLAnalyzer newDefault 
		clusterizationOf: (Array with: 1@2 with: 3@4))
		clusters.
!

!FLAnalysis class methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 9/18/2012 10:59'!
newWith: aMapper private: privateMapper root: anObject

	^self basicNew
		initializeWith: aMapper private: privateMapper root: anObject;
		yourself.! !

!FLAnalysis methodsFor: 'accessing' stamp: 'MartinDias 9/9/2011 21:47'!
clusterization

	^clusterization! !

!FLAnalysis methodsFor: 'hooks' stamp: 'MartinDias 3/29/2012 03:05'!
fuelAccept: aGeneralMapper
	^ aGeneralMapper visitSubstitution: self by: nil! !

!FLAnalysis methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 9/18/2012 10:58'!
initializeWith: aMapper private: privateMapper root: anObject

	self initialize.
	firstMapper := aMapper.
	privateFirstMapper := privateMapper.
	aMapper analysis: self.
	privateMapper analysis: self.
	root := anObject.
	objectStack := FLSimpleStack new.
	privateObjectStack := FLSimpleStack new.
	clusterization := FLClusterization new.
! !

!FLAnalysis methodsFor: 'mapping' stamp: 'MartinDias 1/8/2012 12:36'!
mapAndTrace: anObject
	"Map an object to its cluster. Trace its references."

	firstMapper mapAndTrace: anObject! !

!FLAnalysis methodsFor: 'mapping' stamp: 'MarianoMartinezPeck 9/18/2012 10:58'!
privateMapAndTrace: anObject
	"Map an object to its cluster. Trace its references."

	privateFirstMapper mapAndTrace: anObject! !

!FLAnalysis methodsFor: 'tracing' stamp: 'MarianoMartinezPeck 9/18/2012 10:58'!
privateTrace: anObject

	privateObjectStack push: anObject! !

!FLAnalysis methodsFor: 'analyzing' stamp: 'MarianoMartinezPeck 9/18/2012 10:58'!
run

	objectStack push: root.
	[ objectStack isEmpty ] 
		whileFalse: [ self mapAndTrace: objectStack pop ].
	[ privateObjectStack isEmpty ] 
		whileFalse: [ self privateMapAndTrace: privateObjectStack pop ].! !

!FLAnalysis methodsFor: 'tracing' stamp: 'MartinDias 8/20/2011 22:11'!
trace: anObject

	objectStack push: anObject! !

Object subclass: #FLAnalyzer
	instanceVariableNames: 'internalClasses pluggableSubstitutions globalMappersFactory analysisFactory generalMapperFactory globalSymbols internalMethods globalMappers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core'!

!FLAnalyzer commentStamp: 'MartinDias 8/29/2011 19:15' prior: 0!
I am responsible of traversing the graph of references starting from a root object. I will produce a clusterization which the serializer will store on a stream.

An example of use is:

	(FLAnalyzer newDefault 
		clusterizationOf: (Array with: 1@2 with: 3@4))
		clusters.
!

!FLAnalyzer class methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/17/2012 16:42'!
defaultGlobalSymbols

    ^ #(#Smalltalk #SourceFiles #Transcript #Undeclared #Display #TextConstants #ActiveWorld #ActiveHand #ActiveEvent #Sensor #Processor #ImageImports #SystemOrganization #World) select: [:each |  (Smalltalk globals includesKey: each)]
! !

!FLAnalyzer class methodsFor: 'instance creation' stamp: 'MartinDias 9/9/2011 21:25'!
newDefault
	"Returns an instance with default configuration."

	^self new! !

!FLAnalyzer methodsFor: 'analyzing' stamp: 'MartinDias 9/14/2011 00:15'!
analysisFor: anObject

	^analysisFactory value: anObject! !

!FLAnalyzer methodsFor: 'configuring' stamp: 'MartinDias 12/30/2011 19:25'!
considerGlobal: aSymbol 

	globalSymbols add: aSymbol! !

!FLAnalyzer methodsFor: 'protected' stamp: 'MartinDias 1/10/2012 14:25'!
firstInMapperChain

	^ self mappers first
! !

!FLAnalyzer methodsFor: 'hooks' stamp: 'MartinDias 3/29/2012 03:05'!
fuelAccept: aGeneralMapper
	^ aGeneralMapper visitSubstitution: self by: nil! !

!FLAnalyzer methodsFor: 'defaults' stamp: 'MarianoMartinezPeck 12/14/2011 20:43'!
generalMapper

	^generalMapperFactory value! !

!FLAnalyzer methodsFor: 'accessing' stamp: 'MartinDias 9/11/2011 11:22'!
globalMappers
	
	^globalMappersFactory value! !

!FLAnalyzer methodsFor: 'configuring' stamp: 'MartinDias 1/10/2012 14:41'!
globalSymbols
	"Answer the collection of symbols whose associations and values in Smalltalk globals will be considered as globals by Fuel."
	
	^ globalSymbols! !

!FLAnalyzer methodsFor: 'initialize-release' stamp: 'MartinDias 5/21/2012 12:30'!
initialize

	super initialize.
	self setDefaultAnalysis.
	self useLightMappers.
	pluggableSubstitutions := OrderedCollection new.
	internalClasses := IdentitySet new.
	internalMethods := IdentitySet new. 
	globalSymbols := self class defaultGlobalSymbols asIdentitySet.
! !

!FLAnalyzer methodsFor: 'protected' stamp: 'MartinDias 12/31/2011 00:11'!
lightGlobalMappers

	^ globalSymbols isEmpty
		ifTrue: [#()]
		ifFalse: [Array with: (FLLightGlobalMapper for: globalSymbols)]! !

!FLAnalyzer methodsFor: 'protected' stamp: 'MartinDias 1/10/2012 14:21'!
mappers

	^ OrderedCollection new
		addAll: self pluggableSubstitutionMappers;
		addAll: self globalMappers;
		add: self generalMapper;
		reduceRight: [:left :right | left next: right ];
		yourself! !

!FLAnalyzer methodsFor: 'protected' stamp: 'MartinDias 9/10/2011 17:55'!
pluggableSubstitutionMappers

	^pluggableSubstitutions collect: [:aLink |
		FLPluggableSubstitutionMapper 
			when: aLink key
			substituteBy: aLink value]! !

!FLAnalyzer methodsFor: 'protected' stamp: 'MarianoMartinezPeck 9/18/2012 11:00'!
privateFirstInMapperChain

	^ self privateMappers first
! !

!FLAnalyzer methodsFor: 'protected' stamp: 'MarianoMartinezPeck 9/18/2012 11:00'!
privateMappers

	^ OrderedCollection new
		addAll: self globalMappers;
		add: self generalMapper;
		reduceRight: [:left :right | left next: right ];
		yourself! !

!FLAnalyzer methodsFor: 'protected' stamp: 'MarianoMartinezPeck 9/18/2012 11:00'!
setDefaultAnalysis

	analysisFactory := [:anObject | 
		(FLAnalysis 
			newWith: self firstInMapperChain 
			private: self privateFirstInMapperChain
			root: anObject)
			run;
			yourself ]! !

!FLAnalyzer methodsFor: 'accessing' stamp: 'MartinDias 5/21/2012 12:30'!
useLightMappers

	globalMappersFactory := [self lightGlobalMappers].
	generalMapperFactory := [FLLightGeneralMapper new].! !

!FLAnalyzer methodsFor: 'configuring' stamp: 'MartinDias 9/10/2011 17:04'!
when: aCondition substituteBy: aFactory

	pluggableSubstitutions add: aCondition -> aFactory! !

Object subclass: #FLCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Clusters'!

!FLCluster commentStamp: 'MartinDias 8/29/2011 19:20' prior: 0!
I represent a cluster of objects grouped by some specific similarity. I know how to serialize and materialize them all together.!

!FLCluster class methodsFor: 'analyzing' stamp: 'MartinDias 1/8/2012 15:36'!
clusterBucketIn: aClusterization
	"Answer in which clusters bucket place this cluster. This defines the sort order in which the clusters will be ordered. See FLAnalyzer >> clusteredObjects for more information."

	self subclassResponsibility ! !

!FLCluster class methodsFor: 'instance creation' stamp: 'MartinDias 1/8/2012 14:33'!
new
	self error: 'Use another instance creation message.'! !

!FLCluster class methodsFor: 'instance creation' stamp: 'MartinDias 1/8/2012 14:32'!
newAnalyzing

	^ self basicNew
		initializeAnalyzing;
		yourself.! !

!FLCluster class methodsFor: 'instance creation' stamp: 'MartinDias 2/17/2012 03:18'!
newMaterializing

	^ self basicNew
		initializeMaterializing;
		yourself.! !

!FLCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 19:48'!
afterMaterializationStepWith: aDecoder
! !

!FLCluster methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 9/19/2012 14:38'!
clusterMaterializeStepWith: aMaterialization
	"Materialize cluster stuff"
! !

!FLCluster methodsFor: 'analyzing' stamp: 'MartinDias 8/29/2011 00:54'!
clusterReferencesDo: aBlock
	"Evaluate a block with each object referenced by the cluster"! !

!FLCluster methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 9/19/2012 14:38'!
clusterSerializeStepWith: aSerialization
	"Serialize cluster stuff"! !

!FLCluster methodsFor: 'hooks' stamp: 'MartinDias 3/29/2012 03:05'!
fuelAccept: aGeneralMapper
	^ aGeneralMapper visitSubstitution: self by: nil! !

!FLCluster methodsFor: 'initialize-release' stamp: 'MartinDias 1/8/2012 14:32'!
initializeAnalyzing

	self initialize.! !

!FLCluster methodsFor: 'initialize-release' stamp: 'MartinDias 1/8/2012 14:36'!
initializeMaterializing

	self initialize.! !

!FLCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 1/8/2012 15:00'!
materializeInstancesStepWith: aDecoder
! !

!FLCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 19:48'!
materializePostInstancesStepWith: aDecoder

! !

!FLCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 19:48'!
materializeReferencesStepWith: aDecoder
! !

!FLCluster methodsFor: 'accessing' stamp: 'MartinDias 8/29/2011 00:50'!
objects
	"Answer the objects that this cluster groups."

	self subclassResponsibility! !

!FLCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 8/29/2011 01:23'!
registerIndexesOn: aDictionary
	"Maps objects with indexes in the dictionary."! !

!FLCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 1/8/2012 15:11'!
serializeInstancesStepWith: anEncoder
! !

!FLCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 19:44'!
serializePostInstancesStepWith: anEncoder
! !

!FLCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 19:44'!
serializeReferencesStepWith: anEncoder
! !

!FLCluster methodsFor: 'analyzing' stamp: 'MarianoMartinezPeck 9/18/2012 11:00'!
traceWith: anAnalysis 

	self clusterReferencesDo: [ :aChild | anAnalysis privateTrace: aChild ]! !

FLCluster subclass: #FLIteratingCluster
	instanceVariableNames: 'objects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Clusters'!

!FLIteratingCluster commentStamp: '<historical>' prior: 0!
I am a template class whose algorithm for serialize a collection of objects consists on delegate the serialization of each individual object to the subclass.!

FLIteratingCluster subclass: #FLCompiledMethodCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Clusters'!

FLCompiledMethodCluster class
	instanceVariableNames: 'transformationForSerializing'!

!FLCompiledMethodCluster commentStamp: '<historical>' prior: 0!
I am a cluster for CompiledMethod instances.

How CompiledMethod trailers are serialized can be established using methods in 'configurating' class-side protocol.!

FLCompiledMethodCluster class
	instanceVariableNames: 'transformationForSerializing'!

!FLCompiledMethodCluster class methodsFor: 'analyzing' stamp: 'MartinDias 1/8/2012 15:37'!
clusterBucketIn: aClusterization

	^aClusterization primitivesBucket! !

!FLCompiledMethodCluster class methodsFor: 'configuring' stamp: 'MartinDias 2/18/2013 17:58'!
setTrailerWithNoChange
	"Make compiled methods be serialized as they are."

	^ self transformationForSerializing: [:aCompiledMethod | aCompiledMethod ]! !

!FLCompiledMethodCluster class methodsFor: 'configuring' stamp: 'MartinDias 2/18/2013 17:58'!
setTrailerWithNoSource
	"Make compiled methods be serialized without source code."

	^ self transformationForSerializing: [:aCompiledMethod |
		aCompiledMethod copyWithTrailerBytes: CompiledMethodTrailer empty ]! !

!FLCompiledMethodCluster class methodsFor: 'configuring' stamp: 'MartinDias 2/18/2013 17:59'!
setTrailerWithSourceCode
	"Make compiled methods be serialized with embedded source code."

	^ self transformationForSerializing: [:aCompiledMethod | 
		aCompiledMethod copyWithTrailerBytes: 
			(CompiledMethodTrailer new sourceCode: aCompiledMethod sourceCode) ]! !

!FLCompiledMethodCluster class methodsFor: 'accessing' stamp: 'MartinDias 2/18/2013 18:07'!
transformationForSerializing 
	"Answer a block closure that receives a CompiledMethod and returns another or the same CompiledMethod ready for being serialized."
	transformationForSerializing isNil ifTrue: [ self setTrailerWithNoSource ].
	^ transformationForSerializing! !

!FLCompiledMethodCluster class methodsFor: 'accessing' stamp: 'MartinDias 2/18/2013 17:58'!
transformationForSerializing: aBlockWithOneArgument 
	transformationForSerializing := aBlockWithOneArgument! !

!FLCompiledMethodCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 20:57'!
materializeInstanceWith: aDecoder

	| compiledMethod header bytecodesPlusTrailerSize |

	header := aDecoder nextEncodedUint32.
	bytecodesPlusTrailerSize := aDecoder nextEncodedUint16.

	compiledMethod := CompiledMethod newMethod: bytecodesPlusTrailerSize header: header.

	compiledMethod initialPC to: compiledMethod size
		do: [ :index | compiledMethod at: index put: aDecoder nextEncodedByte ].
		
	^ compiledMethod! !

!FLCompiledMethodCluster methodsFor: 'protected' stamp: 'MartinDias 12/29/2011 19:48'!
materializeLiteralsTo: compiledMethod with: aDecoder

	1 to: compiledMethod numLiterals 
		do: [ :index | compiledMethod literalAt: index put: aDecoder nextEncodedReference ]
! !

!FLCompiledMethodCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 19:48'!
materializeReferencesStepWith: aDecoder

	objects do: [ :aCompiledMethod | self materializeLiteralsTo: aCompiledMethod with: aDecoder ]! !

!FLCompiledMethodCluster methodsFor: 'analyzing' stamp: 'MartinDias 3/21/2012 19:14'!
referencesOf: aCompiledMethod do: aBlock

	aCompiledMethod fuelPrepare.
	1 to: aCompiledMethod numLiterals
		do: [ :index | aBlock value: (aCompiledMethod literalAt: index) ]! !

!FLCompiledMethodCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 2/18/2013 17:58'!
serializeInstance: aCompiledMethodToSerialize with: anEncoder

	| header bytecodesPlusTrailerSize cmSize cmInitialPC aCompiledMethod |

	aCompiledMethod := self class transformationForSerializing value: aCompiledMethodToSerialize.

	header := aCompiledMethod header.
	cmSize := aCompiledMethod size.
	cmInitialPC := aCompiledMethod initialPC.
	bytecodesPlusTrailerSize := cmSize - cmInitialPC + 1.

	anEncoder 
		encodeUint32: header;
		encodeUint16: bytecodesPlusTrailerSize.	

	cmInitialPC to: cmSize
		do: [ :index | anEncoder encodeByte: (aCompiledMethod at: index) ].! !

!FLCompiledMethodCluster methodsFor: 'protected' stamp: 'MartinDias 3/21/2012 19:14'!
serializeLiteralsOf: aCompiledMethod with: anEncoder

	aCompiledMethod fuelPrepare.
	1 to: aCompiledMethod numLiterals 
		do: [ :index | anEncoder encodeReferenceTo: (aCompiledMethod literalAt: index) ]! !

!FLCompiledMethodCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 19:43'!
serializeReferencesStepWith: anEncoder

	objects do: [ :aCompiledMethod | self serializeLiteralsOf: aCompiledMethod with: anEncoder ]! !

!FLIteratingCluster methodsFor: 'analyzing' stamp: 'MartinDias 10/13/2011 16:26'!
add: anObject traceWith: aAnalysis
	"Add an object to the cluster and trace references."

	objects addIfNotPresent: anObject ifPresentDo: [ ^self ].

	self referencesOf: anObject do: [ :aChild | aAnalysis trace: aChild ].! !

!FLIteratingCluster methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 9/19/2012 14:42'!
clusterMaterializeStepWith: aMaterialization

	super clusterMaterializeStepWith: aMaterialization.
	objects := Array new: aMaterialization decoder nextEncodedPositiveInteger! !

!FLIteratingCluster methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 9/19/2012 14:41'!
clusterSerializeStepWith: aSerialization

	super clusterSerializeStepWith: aSerialization.
	aSerialization encoder encodePositiveInteger: objects size.! !

!FLIteratingCluster methodsFor: 'initialize-release' stamp: 'MartinDias 1/8/2012 14:32'!
initializeAnalyzing

	super initializeAnalyzing.
	objects := self newAnalyzingCollection.! !

!FLIteratingCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 19:48'!
materializeInstanceWith: aDecoder
	"Hook method that each subclass should customize for its special way of materializing"

	^ self subclassResponsibility! !

!FLIteratingCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 2/17/2012 03:01'!
materializeInstancesStepWith: aDecoder

	1 to: objects size do: [ :index |
		objects 
			at: index 
			put: (self materializeInstanceWith: aDecoder) ].! !

!FLIteratingCluster methodsFor: 'analyzing' stamp: 'MarianoMartinezPeck 4/20/2012 23:31'!
newAnalyzingCollection
	"Answer a collection for the objects that correspond to this cluster."

	^ FLLargeIdentitySet new! !

!FLIteratingCluster methodsFor: 'accessing' stamp: 'MartinDias 8/29/2011 00:59'!
objects

	^objects! !

!FLIteratingCluster methodsFor: 'printing' stamp: 'MartinDias 8/29/2011 01:16'!
printNameOn: aStream

	super printOn: aStream! !

!FLIteratingCluster methodsFor: 'printing' stamp: 'MartinDias 8/29/2011 00:52'!
printOn: aStream

	self printNameOn: aStream.
	aStream nextPutAll: '->'.
	objects printElementsOn: aStream! !

!FLIteratingCluster methodsFor: 'analyzing' stamp: 'MartinDias 8/29/2011 00:56'!
referencesOf: anObject do: aBlock
	"Evaluate a block with each object referenced by anObject"! !

!FLIteratingCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 8/29/2011 01:22'!
registerIndexesOn: aDictionary

	self objects do: [ :instance | aDictionary at: instance put: aDictionary size + 1 ].! !

!FLIteratingCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/30/2011 13:37'!
serializeInstance: anObject with: anEncoder
	"Hook method that each subclass should customize for its special way of serializing"! !

!FLIteratingCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 2/17/2012 03:03'!
serializeInstancesStepWith: anEncoder

	objects do: [ :instance | self serializeInstance: instance with: anEncoder ]! !

FLIteratingCluster subclass: #FLObjectCluster
	instanceVariableNames: 'theClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Clusters'!

!FLObjectCluster commentStamp: 'MartinDias 8/29/2011 19:20' prior: 0!
I implement a generic way of serializing and materializing an object, for those that do not need more special way of doing it.!

FLObjectCluster subclass: #FLAbstractCollectionCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Clusters-Optionals'!

!FLAbstractCollectionCluster commentStamp: '<historical>' prior: 0!
A FLAbstractCollectionCluster is the common behavior for all cluster collections. !

!FLAbstractCollectionCluster class methodsFor: 'analyzing' stamp: 'MarianoMartinezPeck 7/26/2012 17:38'!
clusterBucketIn: aClusterization

	"During the materialization references step, we may send, for example, #hash to the newly materialized objects. #hash can be implemented delegating to OTHER objects which may not have been materialized yet (I mean, its references may not have been set yet). So in this case, we need to let these clusters at the end."
	^aClusterization postBaselevelBucket! !

!FLAbstractCollectionCluster methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 7/26/2012 14:33'!
afterMaterializationStepWith: aDecoder  

	objects do: [ :anObject | anObject fuelAfterMaterialization ]! !

!FLAbstractCollectionCluster methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 7/26/2012 14:06'!
materializeInstanceWith: aDecoder

	^theClass new: aDecoder nextEncodedPositiveInteger! !

!FLAbstractCollectionCluster methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 7/26/2012 14:24'!
materializeReferencesStepWith: aDecoder

	objects do: [ :anObject | self materializeReferencesOf: anObject with: aDecoder ]! !

!FLAbstractCollectionCluster methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 7/26/2012 16:07'!
serializeInstance: anObject with: anEncoder
	anEncoder encodePositiveInteger: anObject size! !

!FLAbstractCollectionCluster methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 7/26/2012 14:22'!
serializeReferencesStepWith: anEncoder

	objects do: [ :anObject | self serializeReferencesOf: anObject with: anEncoder ]! !

FLAbstractCollectionCluster subclass: #FLDictionaryCollectionCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Clusters-Optionals'!

!FLDictionaryCollectionCluster commentStamp: '<historical>' prior: 0!
A FLDictionaryCollectionCluster is a special optional cluster that rather than using the default (variable object) serialization, uses #keysAndValuesDo: to iterate objects and #add: during materialization. This way we avoid analyzing/serializing lots of nil. Also, the rehash is not needed. So far we use it for Dictionary, IdentityDictionary and MethodDictionary.!

!FLDictionaryCollectionCluster methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 7/26/2012 16:13'!
materializeReferencesOf: anObject with: aDecoder
	aDecoder nextEncodedPositiveInteger "anObject size"
		 timesRepeat: 
			[ anObject add: aDecoder nextEncodedReference -> aDecoder nextEncodedReference ]! !

!FLDictionaryCollectionCluster methodsFor: 'analyzing' stamp: 'MarianoMartinezPeck 7/28/2012 22:27'!
referencesOf: anObject do: aBlock
	aBlock value: anObject size.
	anObject
		keysAndValuesDo: [ :key :value | 
			aBlock value: key. 
			aBlock value: value.  ]
! !

!FLDictionaryCollectionCluster methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 7/26/2012 16:15'!
serializeReferencesOf: anObject with: anEncoder
	anEncoder encodePositiveInteger: anObject size.
	anObject keysAndValuesDo: [ :key :value |
		anEncoder encodeReferenceTo: key.
		anEncoder encodeReferenceTo: value.
	]
	! !

FLAbstractCollectionCluster subclass: #FLSimpleCollectionCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Clusters-Optionals'!

!FLSimpleCollectionCluster commentStamp: '<historical>' prior: 0!
A FLSimpleCollectionCluster is a special optional cluster that rather than using the default (variable object) serialization, uses #do: to iterate objects and #add: during materialization. So far we use it for Set, IdentitySet and OrderedCollection.!

!FLSimpleCollectionCluster methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 7/26/2012 16:10'!
materializeReferencesOf: anObject with: aDecoder
	aDecoder nextEncodedPositiveInteger "anObject size"
		 timesRepeat: 
			[ anObject add: aDecoder nextEncodedReference ]! !

!FLSimpleCollectionCluster methodsFor: 'analyzing' stamp: 'MarianoMartinezPeck 7/28/2012 22:27'!
referencesOf: anObject do: aBlock
	aBlock value: anObject size.
	anObject
		do: [ :each | aBlock value: each ]
! !

!FLSimpleCollectionCluster methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 7/26/2012 16:10'!
serializeReferencesOf: anObject with: anEncoder
	anEncoder encodePositiveInteger: anObject size.
	anObject do: [ :each |
		anEncoder encodeReferenceTo: each ]
	! !

FLObjectCluster subclass: #FLBitsObjectCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Clusters'!

!FLBitsObjectCluster commentStamp: 'MartinDias 8/1/2011 02:59' prior: 0!
I have the common behavior for generic storing and loading variable bits objects.!

!FLBitsObjectCluster methodsFor: 'analyzing' stamp: 'MartinDias 10/13/2011 16:26'!
add: anObject traceWith: aAnalysis
	"Add an object to the cluster. We know the object doesn't have references."

	objects addLast: anObject! !

!FLBitsObjectCluster methodsFor: 'analyzing' stamp: 'MartinDias 1/8/2012 13:12'!
newAnalyzingCollection
	"Answer a collection for the objects that correspond to this cluster."

	^OrderedCollection new! !

!FLBitsObjectCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/13/2011 16:26'!
registerIndexesOn: aDictionary

	self flag: #todo. "Converting objects collection here in this method is a bit confusing. This is because since this cluster is for primitives, they do not have pointers to other objects. Hence, instead of storing them in a IdentitySet we can use an OrderedCollection and then just convert them at the end. For more details see FLBitsObjectCluster >> #add: anObject traceWith: aAnalysis"
	objects := objects asIdentitySet.
	super registerIndexesOn: aDictionary.! !

FLBitsObjectCluster subclass: #FLByteObjectCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Clusters'!

!FLByteObjectCluster commentStamp: 'MartinDias 8/1/2011 02:59' prior: 0!
I am the generic cluster for storing and loading variable byte objects.!

!FLByteObjectCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/30/2011 02:24'!
materializeInstanceWith: aDecoder

	| instance size |
	size := aDecoder nextEncodedPositiveInteger.
	instance := theClass basicNew: size.
	aDecoder nextEncodedBytesInto: instance.
	^ instance
! !

!FLByteObjectCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 20:03'!
serializeInstance: anObject with: anEncoder

	anEncoder encodePositiveInteger: anObject basicSize.
	anEncoder encodeBytes: anObject.! !

FLBitsObjectCluster subclass: #FLWordObjectCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Clusters'!

!FLWordObjectCluster commentStamp: 'MarianoMartinezPeck 9/6/2011 22:50' prior: 0!
I am the generic cluster for storing and loading variable word objects. Most word-like objects are subclasses from ArrayedCollection. Hence, we may have used the method #writeOn: to serialize, and #newFromStream: to materialize. 

#writeOn: is slow because it ALWAYS encode wors in a big endian format. Most machines today are even little endian. Even worst, #newFromStream: has to always do a #restoreEndianness. 

#newFromStream: is fast because it uses the method #nextWordsInto: which is a hack but that is really fast. The problem is that #nextWordsInto: has to always do the #restoreEndianness when we are in little endian machines (most of the time).

Hence, this cluster provives the best of both worlds: the serialization is done with a platform-dependen way, that is, the endianness will be the same of the machine where we are serializing. In addition, we serialize with the same hack that #nextWordsInto: uses, that is, the Bitmap >> hackBits:
And the materialization will use a variation of #nextWordsInto:  (#fuelNextWordsInto:) that ONLY does the #restoreEndianness if the machine where we are materializing has a different endianness than where we have serialized the object. To do this, while serializing, we store in the header of the Fuel stream, the endianness. Then in materialization, we compare agains that. 

Conclusion: we only restore endianness when needed.

Notice, in addition, that the method #newFromStream: sends the message #restoreEndianness. This method EXPECTS that the object was serialized in big endian format, and it will only change the endianness if we are materializing in a little endian machine. This means that if you serialize in little endian and materialize in big endian, you are screw.  For this reason, this cluster uses a method that always change the endianness, Bitmap class >> swapBytesIn:from:to: 

Future work: maybe we can modify and use the Bitmap hackBits:   not only for materialization but also for serialization. 
!

!FLWordObjectCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 20:59'!
materializeInstanceWith: aDecoder

	| inst wideSize |

	wideSize :=  aDecoder nextEncodedPositiveInteger.
	inst := theClass basicNew: wideSize.	

	aDecoder nextEncodedWordsInto: inst. 

	(aDecoder isBigEndian = Smalltalk isBigEndian asBit)
		ifTrue: [^ inst ]
		ifFalse: [ ^ self swapBytesOf: inst ] 
	! !

!FLWordObjectCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 20:05'!
serializeInstance: aWordObject with: anEncoder

	anEncoder encodePositiveInteger: aWordObject basicSize.
	anEncoder encodeWords: aWordObject

! !

!FLWordObjectCluster methodsFor: 'endianness' stamp: 'MarianoMartinezPeck 9/6/2011 12:34'!
swapBytesOf: aWordObject
	Bitmap
                swapBytesIn: aWordObject
                from: 1
                to: aWordObject basicSize.
	^ aWordObject! !

!FLObjectCluster class methodsFor: 'analyzing' stamp: 'MartinDias 1/8/2012 15:38'!
clusterBucketIn: aClusterization

	^aClusterization baselevelBucket ! !

!FLObjectCluster class methodsFor: 'instance creation' stamp: 'MartinDias 1/8/2012 14:31'!
newAnalyzing: aClass

	^ self basicNew
		initializeAnalyzing: aClass;
		yourself.! !

!FLObjectCluster methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 9/19/2012 14:42'!
clusterMaterializeStepWith: aMaterialization

	super clusterMaterializeStepWith: aMaterialization.
	theClass := aMaterialization decoder nextEncodedReference.
! !

!FLObjectCluster methodsFor: 'analyzing' stamp: 'MartinDias 5/30/2011 03:45'!
clusterReferencesDo: aBlock

	aBlock value: theClass! !

!FLObjectCluster methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 9/19/2012 14:41'!
clusterSerializeStepWith: aSerialization

	super clusterSerializeStepWith: aSerialization.
	aSerialization encoder encodeReferenceTo: theClass.! !

!FLObjectCluster methodsFor: 'initialize-release' stamp: 'MartinDias 1/11/2012 00:36'!
initializeAnalyzing: aClass

	self initializeAnalyzing.
	theClass := aClass! !

!FLObjectCluster methodsFor: 'printing' stamp: 'MarianoMartinezPeck 10/24/2011 10:58'!
printNameOn: aStream
	"Append to the argument, aStream, a sequence of characters that  
	identifies the receiver."
	
	super printNameOn: aStream.
	aStream nextPut: $[.
	theClass printOn: aStream.
	aStream nextPut: $].
	! !

!FLObjectCluster methodsFor: 'printing' stamp: 'MarianoMartinezPeck 12/9/2011 20:26'!
theClass 
	^ theClass! !

FLObjectCluster subclass: #FLPointerObjectCluster
	instanceVariableNames: 'variablesMapping'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Clusters'!

!FLPointerObjectCluster commentStamp: 'MartinDias 8/1/2011 03:00' prior: 0!
I have the common behavior for storing and loading pointer objects.!

FLPointerObjectCluster subclass: #FLFixedObjectCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Clusters'!

!FLFixedObjectCluster commentStamp: 'MartinDias 5/30/2011 01:25' prior: 0!
I am a generic cluster for objects without indexable variables.!

!FLFixedObjectCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 19:48'!
materializeInstanceWith: aDecoder

	^theClass basicNew! !

!FLFixedObjectCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 2/17/2012 03:05'!
serializeInstancesStepWith: anEncoder
	"Do nothing. I know my objects have nothing to serialize in this step."
! !

FLPointerObjectCluster subclass: #FLGlobalSendCluster
	instanceVariableNames: 'globalSends'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Clusters'!

!FLGlobalSendCluster commentStamp: 'MarianoMartinezPeck 10/23/2011 14:39' prior: 0!
I clusterize objects that will be obtained on materialization via a message send to a global object. 

Explained with an example:

Suppose we have a special instance of User that represents the admin user, and it is a unique instance in the image. In case the admin user is referenced in our graph, we want to treat that object as a global. We can do that in this way:

User >> fuelAccept: aVisitor
    ^self == User admin
        ifTrue: [aVisitor visitGlobalSend: self]
        ifFalse: [super fuelAccept: aVisitor]

User >> fuelGlobalName
    ^#User

User >> fuelSelector
    ^#admin

So what will happen is that during serialization, the admin user won't be completly serialized (with all its intance variables) but instead its global name and selector are stored. Then, at materialization time, Fuel will send the selector #admin to the class User, and use what that answers as the admin user of the materialized graph.

We test this feature in FLGlobalSendSerializationTest.!

!FLGlobalSendCluster methodsFor: 'mapping' stamp: 'MartinDias 1/10/2012 02:53'!
add: anObject name: globalName selector: selector traceWith: anAnalysis

	self add: anObject traceWith: anAnalysis.
	globalSends
		at: anObject
		ifAbsentPut: [ Association key: globalName value: selector ]! !

!FLGlobalSendCluster methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 11/17/2012 12:49'!
initializeAnalyzing
	super initializeAnalyzing.
	globalSends := IdentityDictionary new.! !

!FLGlobalSendCluster methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 10/19/2012 23:00'!
materializeInstanceWith: aDecoder

	| global selector |
	global := (FLGlobalCluster basicNew materializeGlobalAssociationFrom: aDecoder) value.	
	selector := aDecoder nextEncodedString asSymbol.
	^ global perform: selector! !

!FLGlobalSendCluster methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 10/19/2012 23:00'!
serializeInstance: anObject with: anEncoder
	
	| globalSend |
	globalSend := globalSends at: anObject.
	
	FLGlobalCluster basicNew serializeGlobalAssociationKeyed: globalSend key on: anEncoder.
	anEncoder encodeString: globalSend value.
! !

!FLPointerObjectCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 19:48'!
afterMaterializationStepWith: aDecoder  

	objects do: [ :anObject | anObject fuelAfterMaterialization ]! !

!FLPointerObjectCluster methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 9/19/2012 14:42'!
clusterMaterializeStepWith: aMaterialization

	super clusterMaterializeStepWith: aMaterialization.
	variablesMapping := aMaterialization decoder variablesMappingFor: theClass.! !

!FLPointerObjectCluster methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 9/19/2012 14:41'!
clusterSerializeStepWith: aSerialization

	super clusterSerializeStepWith: aSerialization.
	variablesMapping serializeOn: aSerialization encoder.! !

!FLPointerObjectCluster methodsFor: 'initialize-release' stamp: 'MartinDias 1/8/2012 14:40'!
initializeAnalyzing: aClass

	super initializeAnalyzing: aClass.
	variablesMapping := FLVariablesMapping newAnalyzing: theClass.
! !

!FLPointerObjectCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 19:48'!
materializeReferencesOf: anObject with: aDecoder

	variablesMapping materializeReferencesOf: anObject with: aDecoder! !

!FLPointerObjectCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 19:48'!
materializeReferencesStepWith: aDecoder

	objects do: [ :anObject | self materializeReferencesOf: anObject with: aDecoder ]! !

!FLPointerObjectCluster methodsFor: 'analyzing' stamp: 'MartinDias 12/22/2011 15:07'!
referencesOf: anObject do: aBlock

	variablesMapping referencesOf: anObject do: aBlock! !

!FLPointerObjectCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 19:43'!
serializeReferencesOf: anObject with: anEncoder
	
	variablesMapping serializeReferencesOf: anObject with: anEncoder
! !

!FLPointerObjectCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 19:43'!
serializeReferencesStepWith: anEncoder

	objects do: [ :anObject | self serializeReferencesOf: anObject with: anEncoder ]! !

FLPointerObjectCluster subclass: #FLVariableObjectCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Clusters'!

!FLVariableObjectCluster commentStamp: 'MartinDias 5/30/2011 01:25' prior: 0!
I am a generic cluster for objects with indexable variables.!

FLVariableObjectCluster subclass: #FLMethodContextCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Clusters'!

!FLMethodContextCluster commentStamp: 'MartinDias 5/30/2011 01:18' prior: 0!
I am a cluster for MethodContexts.!

!FLMethodContextCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 20:58'!
materializeInstanceWith: aDecoder

	^ theClass newFromFrameSize: aDecoder nextEncodedByte
! !

!FLMethodContextCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 20:04'!
serializeInstance: aMethodContext with: anEncoder

	anEncoder encodeByte: aMethodContext method frameSize.
! !

!FLVariableObjectCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 19:48'!
materializeInstanceWith: aDecoder

	^theClass basicNew: aDecoder nextEncodedPositiveInteger! !

!FLVariableObjectCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 3/23/2012 12:34'!
materializeReferencesOf: anObject with: aDecoder

	super materializeReferencesOf: anObject with: aDecoder.
	self materializeReferencesVariablePartOf: anObject with: aDecoder.! !

!FLVariableObjectCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 3/23/2012 12:34'!
materializeReferencesVariablePartOf: anObject with: aDecoder

	1 to: anObject basicSize 
		do: [ :index | anObject basicAt: index put: aDecoder nextEncodedReference ]! !

!FLVariableObjectCluster methodsFor: 'analyzing' stamp: 'MartinDias 12/22/2011 14:22'!
referencesOf: anObject do: aBlock

	super referencesOf: anObject do: aBlock.
	self variablePartReferencesOf: anObject do: aBlock. 

! !

!FLVariableObjectCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 19:44'!
serializeInstance: anObject with: anEncoder

	anEncoder encodePositiveInteger: anObject basicSize! !

!FLVariableObjectCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 19:44'!
serializeReferencesOf: anObject with: anEncoder

	super serializeReferencesOf: anObject with: anEncoder.
	self serializeReferencesVariablePartOf: anObject with: anEncoder. ! !

!FLVariableObjectCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 19:44'!
serializeReferencesVariablePartOf: anObject with: anEncoder
	
	1 to: anObject basicSize do: [ :index |
		anEncoder encodeReferenceTo: (anObject basicAt: index) ]! !

!FLVariableObjectCluster methodsFor: 'analyzing' stamp: 'MarianoMartinezPeck 12/6/2011 18:41'!
variablePartReferencesOf: anObject do: aBlock 

	1 to: anObject basicSize 
		do: [ :index | aBlock value: (anObject basicAt: index) ]! !

FLVariableObjectCluster subclass: #FLWeakVariableObjectCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Clusters'!

!FLWeakVariableObjectCluster commentStamp: '<historical>' prior: 0!
I am a cluster for objects with weak indexable variables.!

!FLWeakVariableObjectCluster methodsFor: 'analyzing' stamp: 'MartinDias 2/17/2012 03:24'!
clusterReferencesDo: aBlock
	"Ensures that nil could be encoded, later in references step."

	super clusterReferencesDo: aBlock.
	aBlock value: nil! !

!FLWeakVariableObjectCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 19:44'!
serializeReferencesVariablePartOf: anObject with: anEncoder
	
	1 to: anObject basicSize do: [ :index |
		anEncoder encodeWeakReferenceTo: (anObject basicAt: index) ]! !

!FLWeakVariableObjectCluster methodsFor: 'analyzing' stamp: 'MarianoMartinezPeck 12/6/2011 19:22'!
variablePartReferencesOf: anObject do: aBlock 
	"Since the variable part of Weak classes are weak references, we should not do nothing here."! !

FLIteratingCluster subclass: #FLOptimizedObjectCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Clusters-Optionals'!

!FLOptimizedObjectCluster commentStamp: '<historical>' prior: 0!
I have shared behavior of some optional clusters.!

!FLOptimizedObjectCluster class methodsFor: 'analyzing' stamp: 'MartinDias 1/8/2012 15:39'!
clusterBucketIn: aClusterization

	^aClusterization baselevelBucket ! !

!FLOptimizedObjectCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/30/2011 13:41'!
materializeReferencesOf: anObject with: aDecoder
	"Hook method"

	self subclassResponsibility! !

!FLOptimizedObjectCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 19:48'!
materializeReferencesStepWith: aDecoder

	objects do: [ :anObject | self materializeReferencesOf: anObject with: aDecoder ]! !

!FLOptimizedObjectCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 2/17/2012 03:05'!
serializeInstancesStepWith: anEncoder
	"Do nothing. I know my objects have nothing to serialize in this step."
! !

!FLOptimizedObjectCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 19:43'!
serializeReferencesOf: anObject with: anEncoder
	^ self subclassResponsibility ! !

!FLOptimizedObjectCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 19:43'!
serializeReferencesStepWith: anEncoder

	objects do: [ :anObject | self serializeReferencesOf: anObject with: anEncoder ]! !

FLOptimizedObjectCluster subclass: #FLPointCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Clusters-Optionals'!

!FLPointCluster commentStamp: 'MarianoMartinezPeck 9/8/2011 22:33' prior: 0!
FLPointCluster is an optional class that optimizes Point instances, since there are a lot of instances in the system, it makes sense to optimize them. We take advantage of bytecode optimizations done by Pharo for messages like #@, #x and #y. In addition, we avoid the overhead of class reshape, etc. !

!FLPointCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 19:48'!
materializeInstanceWith: aDecoder
	"Since in Pharo #@ is associated with a special bytecode, it is faster than doing  Point basicNew"
	^ 0@0 
	! !

!FLPointCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 19:48'!
materializeReferencesOf: aPoint with: aDecoder

		aPoint setX: aDecoder nextEncodedReference setY: aDecoder nextEncodedReference.	
! !

!FLPointCluster methodsFor: 'analyzing' stamp: 'MarianoMartinezPeck 9/8/2011 21:37'!
referencesOf: aPoint do: aBlock

	aBlock value: aPoint x.
	aBlock value: aPoint y.
	! !

!FLPointCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 19:43'!
serializeReferencesOf: aPoint with: anEncoder

		anEncoder encodeReferenceTo: aPoint x.
		anEncoder encodeReferenceTo: aPoint y.
! !

FLOptimizedObjectCluster subclass: #FLRectangleCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Clusters-Optionals'!

!FLRectangleCluster commentStamp: 'MarianoMartinezPeck 9/8/2011 22:53' prior: 0!
FLRectangleCluster is an optional class that optimizes Rectangle instances, since there are a lot of instances in the system, it makes sense to optimize them. We take advantage of bytecode optimizations done by Pharo for messages like #new, #@, #x and #y. In addition, we avoid the overhead of class reshape, etc. !

!FLRectangleCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 19:48'!
materializeInstanceWith: aDecoder
	"Since in Pharo #@ is associated with a special bytecode, it is faster than doing  Point basicNew"
	^ Rectangle basicNew! !

!FLRectangleCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 19:48'!
materializeReferencesOf: aRectangle with: aDecoder
		
		aRectangle 
			setOrigin: aDecoder nextEncodedReference @ aDecoder nextEncodedReference	
		 	corner: aDecoder nextEncodedReference @ aDecoder nextEncodedReference.	
	 ! !

!FLRectangleCluster methodsFor: 'analyzing' stamp: 'MarianoMartinezPeck 9/8/2011 22:45'!
referencesOf: aRectangle do: aBlock

	aBlock value: aRectangle origin x.
	aBlock value: aRectangle origin y.
	aBlock value: aRectangle corner x.
	aBlock value: aRectangle corner y.! !

!FLRectangleCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 19:43'!
serializeReferencesOf: aRectangle with: anEncoder

		anEncoder encodeReferenceTo: aRectangle origin x.
		anEncoder encodeReferenceTo: aRectangle origin y.
		anEncoder encodeReferenceTo: aRectangle corner x.
		anEncoder encodeReferenceTo: aRectangle corner y.
! !

FLIteratingCluster subclass: #FLPrimitiveCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Clusters'!

!FLPrimitiveCluster commentStamp: 'MartinDias 8/29/2011 19:21' prior: 0!
I am a cluster that serializes and materializes interacting directly with the stream.!

FLPrimitiveCluster subclass: #FLGlobalCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Clusters'!

!FLGlobalCluster commentStamp: 'MartinDias 9/16/2011 14:49' prior: 0!
I am a cluster for objects that are reachables from Smalltalk global dictionary.!

FLGlobalCluster subclass: #FLGlobalAssociationCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Clusters'!

!FLGlobalAssociationCluster commentStamp: 'MartinDias 5/30/2011 01:28' prior: 0!
I am a cluster for variable bindings that belong to Smalltalk global dictionary.

For example, 

	Smalltalk globals associationAt: #Transcript 
	
could be serialized and materialized by me.!

!FLGlobalAssociationCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/30/2011 12:29'!
materializeInstanceWith: aDecoder

	^self materializeGlobalAssociationFrom: aDecoder! !

!FLGlobalAssociationCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/30/2011 12:27'!
serializeInstance: anAssociation with: anEncoder
	
	self serializeGlobalAssociationKeyed: anAssociation key on: anEncoder ! !

FLGlobalCluster subclass: #FLGlobalClassCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Clusters'!

!FLGlobalClassCluster commentStamp: 'MartinDias 5/30/2011 01:28' prior: 0!
I am a cluster for classes that should be present when materializing. In other words, it only serializes a reference to the class, using its name.!

!FLGlobalClassCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/30/2011 12:29'!
materializeInstanceWith: aDecoder

	^self materializeGlobalClassFrom: aDecoder ! !

!FLGlobalClassCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/30/2011 12:27'!
serializeInstance: aClass with: anEncoder
	
	self serializeGlobalClass: aClass on: anEncoder! !

FLGlobalCluster subclass: #FLGlobalClassSideCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Clusters'!

!FLGlobalClassSideCluster commentStamp: 'MartinDias 8/1/2011 02:57' prior: 0!
I am a cluster for those Metaclasses and ClassTrait who are not stored in detail.!

!FLGlobalClassSideCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/30/2011 12:29'!
materializeInstanceWith: aDecoder

	^(self materializeGlobalClassFrom: aDecoder) classSide! !

!FLGlobalClassSideCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/30/2011 12:27'!
serializeInstance: aClassOrTraitClassSide with: anEncoder

	self serializeGlobalClass: aClassOrTraitClassSide instanceSide on: anEncoder
! !

!FLGlobalCluster class methodsFor: 'analyzing' stamp: 'MartinDias 1/8/2012 15:38'!
clusterBucketIn: aClusterization

	^aClusterization globalsBucket ! !

!FLGlobalCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/30/2011 12:23'!
materializeGlobalAssociationFrom: aDecoder

	| globalName |
	globalName := aDecoder nextEncodedString asSymbol.
	^Smalltalk globals 
		associationAt: globalName
		ifAbsent: [ FLGlobalNotFound signalWithName: globalName ]
! !

!FLGlobalCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 1/5/2012 01:05'!
materializeGlobalClassFrom: aDecoder

	| className |
	className := aDecoder nextEncodedString asSymbol.
	^ aDecoder classNamed: className! !

!FLGlobalCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/30/2011 12:24'!
serializeGlobalAssociationKeyed: aSymbol on: anEncoder
	
	anEncoder encodeString: aSymbol! !

!FLGlobalCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/30/2011 12:24'!
serializeGlobalClass: aClass on: anEncoder
	
	aClass isObsolete ifTrue: [ FLObsolete signalWithName: aClass name ].
	anEncoder encodeString: aClass name ! !

FLGlobalCluster subclass: #FLGlobalCompiledMethodCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Clusters'!

!FLGlobalCompiledMethodCluster commentStamp: '<historical>' prior: 0!
I clusterize CompiledMethods that will be obtained on materialization accessing method dictionary of the corresponding class in Smalltalk globals.
!

!FLGlobalCompiledMethodCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 3/20/2012 00:38'!
materializeInstanceWith: aDecoder

	| methodClass selector method serializedHash |
	methodClass := self materializeGlobalClassFrom: aDecoder.
	(aDecoder nextEncodedByte = 1) ifTrue: [
		methodClass := methodClass classSide].
	selector := aDecoder nextEncodedString asSymbol.
	method := methodClass  
		compiledMethodAt: selector
		ifAbsent: [FLMethodNotFound signalWith: methodClass name and: selector].
	serializedHash := aDecoder nextEncodedUint16.
	method bytecodesHash =  serializedHash
		ifFalse: [FLMethodChanged signalWith: methodClass name and: selector].
	^method! !

!FLGlobalCompiledMethodCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 3/20/2012 00:38'!
serializeInstance: aCompiledMethod with: anEncoder
	| methodClass |
	methodClass := aCompiledMethod methodClass.
	self serializeGlobalClass: methodClass instanceSide on: anEncoder.
	anEncoder encodeByte: (methodClass isClassSide ifTrue: [1] ifFalse: [0]).
	anEncoder encodeString: aCompiledMethod selector.
	anEncoder encodeUint16: aCompiledMethod bytecodesHash.! !

FLGlobalCluster subclass: #FLGlobalValueCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Clusters'!

!FLGlobalValueCluster commentStamp: 'MartinDias 5/30/2011 01:28' prior: 0!
I am a cluster for known objects that belong to Smalltalk global dictionary.

For example, Transcript could be serialized and materialized by me.!

!FLGlobalValueCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/30/2011 12:29'!
materializeInstanceWith: aDecoder

	^(self materializeGlobalAssociationFrom: aDecoder) value! !

!FLGlobalValueCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/30/2011 12:27'!
serializeInstance: anObject with: anEncoder
	
	self serializeGlobalAssociationKeyed: (Smalltalk keyAtValue: anObject) on: anEncoder! !

FLPrimitiveCluster subclass: #FLHookPrimitiveCluster
	instanceVariableNames: 'theClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Clusters'!

!FLHookPrimitiveCluster commentStamp: '<historical>' prior: 0!
I am a cluster for simple objects who define serialization and materialization via hooks on their classes.!

!FLHookPrimitiveCluster class methodsFor: 'analyzing' stamp: 'MartinDias 1/8/2012 15:38'!
clusterBucketIn: aClusterization

	^aClusterization primitivesBucket ! !

!FLHookPrimitiveCluster class methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 4/23/2012 16:34'!
newAnalyzing: aClass

	^ self basicNew
		initializeAnalyzing: aClass;
		yourself.! !

!FLHookPrimitiveCluster methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 9/19/2012 14:42'!
clusterMaterializeStepWith: aMaterialization

	super clusterMaterializeStepWith: aMaterialization.
	theClass := aMaterialization decoder nextEncodedReference.
! !

!FLHookPrimitiveCluster methodsFor: 'analyzing' stamp: 'MarianoMartinezPeck 4/23/2012 16:33'!
clusterReferencesDo: aBlock

	aBlock value: theClass! !

!FLHookPrimitiveCluster methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 9/19/2012 14:41'!
clusterSerializeStepWith: aSerialization

	super clusterSerializeStepWith: aSerialization.
	aSerialization encoder encodeReferenceTo: theClass.	! !

!FLHookPrimitiveCluster methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 4/23/2012 16:33'!
initializeAnalyzing: aClass

	super initializeAnalyzing.
	theClass := aClass! !

!FLHookPrimitiveCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/30/2011 10:47'!
materializeInstanceWith: aDecoder
	
	^theClass materializeFrom: aDecoder! !

!FLHookPrimitiveCluster methodsFor: 'printing' stamp: 'MartinDias 5/11/2012 19:23'!
printNameOn: aStream
	"Append to the argument, aStream, a sequence of characters that  
	identifies the receiver."
	
	super printNameOn: aStream.
	aStream nextPut: $[.
	theClass printOn: aStream.
	aStream nextPut: $].! !

!FLHookPrimitiveCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/30/2011 10:48'!
serializeInstance: anObject with: anEncoder

	anObject serializeOn: anEncoder! !

!FLPrimitiveCluster class methodsFor: 'analyzing' stamp: 'MartinDias 1/8/2012 15:39'!
clusterBucketIn: aClusterization

	^aClusterization primitivesBucket ! !

!FLPrimitiveCluster methodsFor: 'analyzing' stamp: 'MartinDias 1/9/2012 17:12'!
add: anObject traceWith: anAnalysis
	"Add an object to the cluster. We know the object doesn't have references."

	objects addLast: anObject! !

!FLPrimitiveCluster methodsFor: 'analyzing' stamp: 'MartinDias 1/8/2012 13:12'!
newAnalyzingCollection
	"Answer a collection for the objects that correspond to this cluster."

	^OrderedCollection new! !

!FLPrimitiveCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/13/2011 16:26'!
registerIndexesOn: aDictionary

	self flag: #todo. "Converting objects collection here in this method is a bit confusing. This is because since this cluster is for primitives, they do not have pointers to other objects. Hence, instead of storing them in a IdentitySet we can use an OrderedCollection and then just convert them at the end. For more details see FLPrimitiveCluster >> #add: anObject traceWith: aAnalysis"
	objects := objects asIdentitySet.
	super registerIndexesOn: aDictionary.! !

FLPrimitiveCluster subclass: #FLSmallIntegerCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Clusters'!

!FLSmallIntegerCluster commentStamp: 'MartinDias 1/7/2012 11:57' prior: 0!
I don't have so much sense as a class.!

FLSmallIntegerCluster subclass: #FLNegative16SmallIntegerCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Clusters'!

!FLNegative16SmallIntegerCluster methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 6/8/2012 22:50'!
materializeInstanceWith: aDecoder
	
	^ aDecoder nextEncodedUint16 negated ! !

!FLNegative16SmallIntegerCluster methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 6/8/2012 22:50'!
serializeInstance: anInteger with: anEncoder
	
	anEncoder encodeUint16: anInteger abs! !

FLSmallIntegerCluster subclass: #FLNegative24SmallIntegerCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Clusters'!

!FLNegative24SmallIntegerCluster methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 6/9/2012 11:52'!
materializeInstanceWith: aDecoder
	
	^ aDecoder nextEncodedUint24 negated ! !

!FLNegative24SmallIntegerCluster methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 6/9/2012 11:52'!
serializeInstance: anInteger with: anEncoder
	
	anEncoder encodeUint24: anInteger abs! !

FLSmallIntegerCluster subclass: #FLNegative32SmallIntegerCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Clusters'!

!FLNegative32SmallIntegerCluster methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 6/8/2012 22:57'!
materializeInstanceWith: aDecoder
	
	^ aDecoder nextEncodedUint32 negated ! !

!FLNegative32SmallIntegerCluster methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 6/8/2012 22:57'!
serializeInstance: anInteger with: anEncoder
	
	anEncoder encodeUint32: anInteger abs! !

FLSmallIntegerCluster subclass: #FLNegative8SmallIntegerCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Clusters'!

!FLNegative8SmallIntegerCluster methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 6/8/2012 22:52'!
materializeInstanceWith: aDecoder

	^ aDecoder nextEncodedUint8 negated! !

!FLNegative8SmallIntegerCluster methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 6/8/2012 22:53'!
serializeInstance: anInteger with: anEncoder

	anEncoder encodeUint8: anInteger abs! !

FLSmallIntegerCluster subclass: #FLPositive16SmallIntegerCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Clusters'!

!FLPositive16SmallIntegerCluster methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 6/8/2012 22:51'!
materializeInstanceWith: aDecoder
	
	^ aDecoder nextEncodedUint16 ! !

!FLPositive16SmallIntegerCluster methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 6/8/2012 22:51'!
serializeInstance: anInteger with: anEncoder
	
	anEncoder encodeUint16: anInteger! !

FLSmallIntegerCluster subclass: #FLPositive24SmallIntegerCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Clusters'!

!FLPositive24SmallIntegerCluster methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 6/9/2012 11:52'!
materializeInstanceWith: aDecoder
	
	^ aDecoder nextEncodedUint24 ! !

!FLPositive24SmallIntegerCluster methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 6/9/2012 11:52'!
serializeInstance: anInteger with: anEncoder
	
	anEncoder encodeUint24: anInteger! !

FLSmallIntegerCluster subclass: #FLPositive32SmallIntegerCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Clusters'!

!FLPositive32SmallIntegerCluster methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 6/8/2012 22:57'!
materializeInstanceWith: aDecoder

	^ aDecoder nextEncodedUint32! !

!FLPositive32SmallIntegerCluster methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 6/8/2012 22:57'!
serializeInstance: anInteger with: anEncoder

	anEncoder encodeUint32: anInteger! !

FLSmallIntegerCluster subclass: #FLPositive8SmallIntegerCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Clusters'!

!FLPositive8SmallIntegerCluster methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 6/8/2012 22:52'!
materializeInstanceWith: aDecoder

	^ aDecoder nextEncodedUint8! !

!FLPositive8SmallIntegerCluster methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 6/8/2012 22:52'!
serializeInstance: anInteger with: anEncoder

	anEncoder encodeUint8: anInteger! !

FLCluster subclass: #FLSubstitutionCluster
	instanceVariableNames: 'substitutions substitutes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Clusters'!

!FLSubstitutionCluster commentStamp: 'MartinDias 1/9/2012 15:04' prior: 0!
I am a cluster for objects that have to be replaced in the object graph by another one (at serialization time).

Examples of use:

1) Suppose you want to substitute instances of WriteStream by nil. In such case, WriteStream has to implement this method:

fuelAccept: aVisitor
	^aVisitor visitSubstitution: self by: nil


2) Suppose you want to substitute every integer in the graph by its string representation. In such case you should configure the analyzer through:

anAnalyzer when: [:x | x isInteger] substituteBy: [:x | x printString].

In this way, when you serialize #(1 2), you will then materialize #('1' '2')!

!FLSubstitutionCluster class methodsFor: 'analyzing' stamp: 'MartinDias 1/8/2012 15:39'!
clusterBucketIn: aClusterization

	^aClusterization substitutionsBucket! !

!FLSubstitutionCluster methodsFor: 'analyzing' stamp: 'MartinDias 5/9/2012 00:14'!
add: anObject substitutedBy: anotherObject traceWith: aAnalysis

	substitutions 
		at: anObject 
		ifAbsent: [ 
			substitutions at: anObject put: anotherObject.
			substitutes add: anotherObject.
			aAnalysis trace: anotherObject ].! !

!FLSubstitutionCluster methodsFor: 'initialize-release' stamp: 'MartinDias 5/9/2012 00:14'!
initializeAnalyzing

	super initializeAnalyzing.
	substitutions := IdentityDictionary new.
	substitutes := IdentitySet new.! !

!FLSubstitutionCluster methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/16/2012 09:32'!
isSubstitute: anObject

	^ substitutes identityIncludes: anObject! !

!FLSubstitutionCluster methodsFor: 'accessing' stamp: 'MartinDias 8/29/2011 01:04'!
objects
	"This cluster does not have objects"
	
	^#()! !

!FLSubstitutionCluster methodsFor: 'printing' stamp: 'MartinDias 8/29/2011 01:16'!
printOn: aStream

	super printOn: aStream.
	aStream nextPutAll: '->'.
	substitutions printElementsOn: aStream! !

!FLSubstitutionCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 8/20/2011 23:18'!
registerIndexesOn: aDictionary

	substitutions keysAndValuesDo: [ :anObject :theSubstitution | 
		| substitutionIndex |
		substitutionIndex := aDictionary at: theSubstitution.
		aDictionary at: anObject put: substitutionIndex. ].! !

!FLSubstitutionCluster methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 5/15/2012 11:52'!
substitutions
	^ substitutions ! !

FLCluster subclass: #FLWellKnownObjectsCluster
	instanceVariableNames: ''
	classVariableNames: 'WellKnownObjects'
	poolDictionaries: ''
	category: 'Fuel-Clusters'!

!FLWellKnownObjectsCluster commentStamp: 'MartinDias 8/1/2011 03:00' prior: 0!
I am a cluster for some well known objects like nil, true and false. They have a special treatment because they are so common in the image.!

!FLWellKnownObjectsCluster class methodsFor: 'analyzing' stamp: 'MartinDias 1/8/2012 15:39'!
clusterBucketIn: aClusterization

	^aClusterization primitivesBucket! !

!FLWellKnownObjectsCluster class methodsFor: 'class initialization' stamp: 'MartinDias 8/30/2011 00:53'!
initialize

	WellKnownObjects := Array
		with: nil
		with: true
		with: false
		with: Smalltalk globals! !

!FLWellKnownObjectsCluster methodsFor: 'analyzing' stamp: 'MartinDias 10/13/2011 16:26'!
add: anObject traceWith: aAnalysis

	"Do nothing. THis is an optimization. As you see, anObject is not added. In the conrary, #registerIndexesOn: directly serializes all the array of WellKnownObjects. See #objects"! !

!FLWellKnownObjectsCluster methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 9/28/2011 23:15'!
objects
	" This is an optimization. We always serialize all the WellKnownObjects"
	^WellKnownObjects! !

!FLWellKnownObjectsCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 8/30/2011 00:46'!
registerIndexesOn: aDictionary

	self objects do: [ :instance | aDictionary at: instance put: aDictionary size + 1 ].! !

Object subclass: #FLClusterization
	instanceVariableNames: 'baselevelBucket substitutionsBucket globalsBucket metalevelInstanceSideBucket metalevelClassSideBucket primitivesBucket postBaselevelBucket'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core'!

!FLClusterization commentStamp: 'MartinDias 8/29/2011 19:12' prior: 0!
I manage the clusters collected during the analysis step of serialization.!

!FLClusterization methodsFor: 'cluster buckets' stamp: 'MartinDias 8/20/2011 22:27'!
baselevelBucket
	
	^ baselevelBucket! !

!FLClusterization methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 7/26/2012 17:36'!
clusterBuckets
	"Answer a new collection with all the clusters that have been collected in trace. Note that order is imporant."

	^ OrderedCollection new 
		add: globalsBucket;
		add: primitivesBucket;
		add: metalevelClassSideBucket;
		add: metalevelInstanceSideBucket;
		add: baselevelBucket;
		add: postBaselevelBucket;
		add: substitutionsBucket;
		yourself.! !

!FLClusterization methodsFor: 'accessing' stamp: 'MartinDias 1/11/2012 00:27'!
clusters
	
	^self clusterBuckets gather: [:c | c ].
! !

!FLClusterization methodsFor: 'hooks' stamp: 'MartinDias 3/29/2012 03:05'!
fuelAccept: aGeneralMapper
	^ aGeneralMapper visitSubstitution: self by: nil! !

!FLClusterization methodsFor: 'cluster buckets' stamp: 'MartinDias 9/15/2011 20:16'!
globalsBucket
	
	^ globalsBucket ! !

!FLClusterization methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 7/26/2012 17:36'!
initialize

	super initialize.
	primitivesBucket := IdentityDictionary new.
	baselevelBucket := IdentityDictionary new.
	globalsBucket := IdentityDictionary new.
	metalevelInstanceSideBucket := IdentityDictionary new.
	metalevelClassSideBucket := IdentityDictionary new.
	substitutionsBucket := IdentityDictionary new.
	postBaselevelBucket := IdentityDictionary new.
! !

!FLClusterization methodsFor: 'cluster buckets' stamp: 'MartinDias 9/17/2011 00:27'!
metalevelClassSideBucket
	
	^ metalevelClassSideBucket! !

!FLClusterization methodsFor: 'cluster buckets' stamp: 'MartinDias 9/17/2011 00:27'!
metalevelInstanceSideBucket
	
	^ metalevelInstanceSideBucket ! !

!FLClusterization methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 1/11/2012 11:02'!
objectCount

	^self clusterBuckets sum: [ :aClusterBucket | 
		aClusterBucket
			inject: 0 
			into: [ :sum :aCluster | sum + aCluster objects size ] ].! !

!FLClusterization methodsFor: 'cluster buckets' stamp: 'MarianoMartinezPeck 7/26/2012 17:36'!
postBaselevelBucket
	
	^ postBaselevelBucket! !

!FLClusterization methodsFor: 'cluster buckets' stamp: 'MartinDias 9/17/2011 00:29'!
primitivesBucket
	
	^ primitivesBucket! !

!FLClusterization methodsFor: 'cluster buckets' stamp: 'MartinDias 8/20/2011 22:52'!
substitutionsBucket
	
	^ substitutionsBucket! !

Object subclass: #FLDecoder
	instanceVariableNames: 'stream objects isBigEndian indexStream migrations objectsWriteStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core'!

!FLDecoder commentStamp: 'MartinDias 1/6/2012 16:08' prior: 0!
I am an abstraction used by the materialization algorithm to decode the graph from a stream.!

!FLDecoder class methodsFor: 'instance creation' stamp: 'MartinDias 1/5/2012 00:12'!
on: aStream migrations: aCollection
	
	^self basicNew
		initializeOn: aStream migrations: aCollection;
		yourself.! !

!FLDecoder methodsFor: 'decoding' stamp: 'MartinDias 1/5/2012 13:12'!
classNamed: className 

	^ (migrations
		detect: [:m | m sourceClassName = className ]
		ifNone: [ ^ self globalClassNamed: className ])
		targetClass.
		! !

!FLDecoder methodsFor: 'decoding' stamp: 'MartinDias 2/17/2012 04:10'!
decodeYourself

	| objectCount |
	objectCount := self nextEncodedPositiveInteger.
	
	indexStream := FLIndexStream on: stream digits: objectCount digitLength.
	objects := Array new: objectCount.
	objectsWriteStream := WriteStream on: objects.

	isBigEndian := self nextEncodedPositiveInteger.
! !

!FLDecoder methodsFor: 'decoding' stamp: 'MartinDias 1/5/2012 01:07'!
globalClassNamed: className

	^ Smalltalk globals 
		at: className
		ifAbsent: [ FLClassNotFound signalWithName: className ]! !

!FLDecoder methodsFor: 'initializing' stamp: 'MartinDias 1/5/2012 00:13'!
initializeOn: aStream migrations: aCollection

	self initialize.
	stream := aStream.
	migrations := aCollection.! !

!FLDecoder methodsFor: 'accessing' stamp: 'MartinDias 12/29/2011 18:27'!
isBigEndian
	^ isBigEndian! !

!FLDecoder methodsFor: 'decoding' stamp: 'MarianoMartinezPeck 1/7/2012 20:09'!
nextEncodedBitmap

	^ Bitmap newFromStream: stream! !

!FLDecoder methodsFor: 'decoding' stamp: 'MartinDias 12/29/2011 21:07'!
nextEncodedByte
	^stream next! !

!FLDecoder methodsFor: 'decoding' stamp: 'MartinDias 12/30/2011 02:25'!
nextEncodedBytesInto: aBytesObject
	stream next: aBytesObject basicSize into: aBytesObject ! !

!FLDecoder methodsFor: 'decoding' stamp: 'MartinDias 2/20/2012 15:37'!
nextEncodedClusterClass

	^ Smalltalk globals at: self nextEncodedString asSymbol! !

!FLDecoder methodsFor: 'decoding' stamp: 'MarianoMartinezPeck 6/9/2012 20:01'!
nextEncodedInt24
	| n firstDigit |
	n := firstDigit := stream next.
	n := (n bitShift: 8) + stream next.
	n := (n bitShift: 8) + stream next.
	firstDigit >= 128 ifTrue: [n := -16r1000000 + n].  "decode negative 24-bit integer"
	^ n
! !

!FLDecoder methodsFor: 'decoding' stamp: 'MarianoMartinezPeck 1/7/2012 14:56'!
nextEncodedInt32
	| n firstDigit |
	n := firstDigit := stream next.
	n := (n bitShift: 8) + stream next.
	n := (n bitShift: 8) + stream next.
	n := (n bitShift: 8) + stream next.
	firstDigit >= 128 ifTrue: [n := -16r100000000 + n].  "decode negative 32-bit integer"
	^ n
! !

!FLDecoder methodsFor: 'decoding' stamp: 'MarianoMartinezPeck 1/7/2012 14:57'!
nextEncodedPositiveInteger
	"Read a 32-bit signed integer from the next 4 bytes"
	| s |
	s := 0.
	1 to: 4 do: [:i | s := (s bitShift: 8) + stream next].
	^ s! !

!FLDecoder methodsFor: 'decoding' stamp: 'MartinDias 12/30/2011 15:34'!
nextEncodedReference 

	^ objects at: indexStream nextIndex! !

!FLDecoder methodsFor: 'decoding' stamp: 'MarianoMartinezPeck 1/7/2012 14:58'!
nextEncodedString
	| length aByteArray |

	"read the length in binary mode"
	length := stream next.		"first byte."
	length >= 192 ifTrue: [length := length - 192.
		1 to: 3 do: [:ii | length := length * 256 + stream next]].
	aByteArray := ByteArray new: length.

	stream nextInto: aByteArray.
	^aByteArray asString.
! !

!FLDecoder methodsFor: 'decoding' stamp: 'MarianoMartinezPeck 6/9/2012 12:32'!
nextEncodedUint16
	"Answer the next unsigned, 16-bit integer from this (binary) stream."
	^ (stream next bitShift: 8) + (stream next).
	! !

!FLDecoder methodsFor: 'decoding' stamp: 'MarianoMartinezPeck 6/9/2012 11:56'!
nextEncodedUint24
	"Answer the next unsigned, 24-bit integer from this (binary) stream."

	| n |
	n := stream next.
	n := (n bitShift: 8) + stream next.
	n := (n bitShift: 8) + stream next.
	^ n
! !

!FLDecoder methodsFor: 'decoding' stamp: 'MarianoMartinezPeck 1/7/2012 14:59'!
nextEncodedUint32
	"Answer the next unsigned, 32-bit integer from this (binary) stream."

	| n |
	n := stream next.
	n := (n bitShift: 8) + stream next.
	n := (n bitShift: 8) + stream next.
	n := (n bitShift: 8) + stream next.
	^ n
! !

!FLDecoder methodsFor: 'decoding' stamp: 'MarianoMartinezPeck 6/8/2012 22:55'!
nextEncodedUint8
	"Answer the next unsigned, 16-bit integer from this (binary) stream."
	^ stream next.
	
! !

!FLDecoder methodsFor: 'decoding' stamp: 'MartinDias 12/29/2011 21:02'!
nextEncodedWordsInto: aWordsObject 
	stream fuelNextWordsInto: aWordsObject ! !

!FLDecoder methodsFor: 'accessing' stamp: 'MartinDias 12/29/2011 18:51'!
objects
	^ objects! !

!FLDecoder methodsFor: 'accessing' stamp: 'MartinDias 2/17/2012 04:06'!
registerAll: someObjects

	objectsWriteStream nextPutAll: someObjects.! !

!FLDecoder methodsFor: 'accessing' stamp: 'MartinDias 1/7/2012 11:54'!
variablesMappingFor: aClass

	| variables |
	variables := FLVariablesMapping materializing: aClass from: self.
	
	migrations 
		select: [ :m | m targetClass == aClass ]
		thenDo: [ :m | m applyTo: variables ].
		
	^ variables
	! !

Object subclass: #FLEncoder
	instanceVariableNames: 'stream objectsIndexes objectCount indexStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core'!

!FLEncoder commentStamp: 'MartinDias 1/6/2012 16:08' prior: 0!
I am an abstraction used by the serialization algorithm to encode the graph in a stream.!

!FLEncoder class methodsFor: 'instance creation' stamp: 'MartinDias 12/29/2011 17:11'!
on: aStream 
	
	^self basicNew
		initializeOn: aStream;
		yourself.! !

!FLEncoder class methodsFor: 'instance creation' stamp: 'MartinDias 1/6/2012 22:48'!
on: aStream do: aBlock
	
	| anEncoder |
	anEncoder := self on: aStream.
	^ [ aBlock value: anEncoder ] ensure: [ anEncoder flush ]! !

!FLEncoder methodsFor: 'encoding' stamp: 'MarianoMartinezPeck 1/7/2012 20:08'!
encodeBitmap: aBitmap 
	"Append to the receiver an Integer as the next two bytes."
	aBitmap writeOn: stream.
! !

!FLEncoder methodsFor: 'encoding' stamp: 'MartinDias 12/29/2011 20:11'!
encodeByte: aSmallInteger 
	stream nextPut: aSmallInteger! !

!FLEncoder methodsFor: 'encoding' stamp: 'MartinDias 12/29/2011 20:16'!
encodeBytes: aBytesObject
	stream nextBytesPutAll: aBytesObject ! !

!FLEncoder methodsFor: 'encoding' stamp: 'MartinDias 2/20/2012 15:37'!
encodeClusterClass: aClusterClass 

	self encodeString: aClusterClass name! !

!FLEncoder methodsFor: 'encoding' stamp: 'MarianoMartinezPeck 6/9/2012 20:00'!
encodeInt24: aSmallInteger 
	"Write a signed integer to the next 4 bytes"
	| pos |
	pos := aSmallInteger < 0
		ifTrue: [((0-aSmallInteger) bitXor: 16rFFFFFF) + 1]
		ifFalse: [aSmallInteger].
	1 to: 3 do: [:i | stream nextPut: (pos digitAt: 4-i)].
! !

!FLEncoder methodsFor: 'encoding' stamp: 'MarianoMartinezPeck 1/7/2012 20:13'!
encodeInt32: aSmallInteger 
	"Write a signed integer to the next 4 bytes"
	| pos |
	pos := aSmallInteger < 0
		ifTrue: [(0-aSmallInteger) bitInvert32 + 1]
		ifFalse: [aSmallInteger].
	1 to: 4 do: [:i | stream nextPut: (pos digitAt: 5-i)].
! !

!FLEncoder methodsFor: 'encoding' stamp: 'MarianoMartinezPeck 1/7/2012 20:13'!
encodePositiveInteger: anInteger
	"Append to the receiver an Integer as the next 4 bytes."
	1 to: 4 do: [:i | stream nextPut: (anInteger digitAt: 4+1-i)].! !

!FLEncoder methodsFor: 'encoding' stamp: 'MarianoMartinezPeck 1/11/2012 22:24'!
encodeReferenceTo: anObject

	indexStream 
		nextIndexPut: (objectsIndexes at: anObject ifAbsent: [FLObjectNotFound signalWith: anObject])! !

!FLEncoder methodsFor: 'encoding' stamp: 'MarianoMartinezPeck 1/7/2012 20:13'!
encodeString: aString
	| length |
	(length := aString size) < 192
		ifTrue: [stream nextPut: length]
		ifFalse: 
			[stream nextPut: (length digitAt: 4)+192.
			stream nextPut: (length digitAt: 3).
			stream nextPut: (length digitAt: 2).
			stream nextPut: (length digitAt: 1)].
	stream nextBytesPutAll: aString.! !

!FLEncoder methodsFor: 'encoding' stamp: 'MarianoMartinezPeck 1/7/2012 20:13'!
encodeUint16: aSmallInteger 
	"Append to the receiver an Integer as the next two bytes."
	stream nextPut: (aSmallInteger bitShift: -8).
	stream nextPut: (aSmallInteger bitAnd: 255).! !

!FLEncoder methodsFor: 'encoding' stamp: 'MarianoMartinezPeck 6/9/2012 12:16'!
encodeUint24: aSmallInteger 
	"Append to the receiver an Integer as the next 3 bytes."
	stream		
		nextPut: ((aSmallInteger bitShift: -16) bitAnd: 255);
		nextPut: ((aSmallInteger bitShift: -8) bitAnd: 255);
		nextPut: (aSmallInteger bitAnd: 255)

! !

!FLEncoder methodsFor: 'encoding' stamp: 'MarianoMartinezPeck 6/9/2012 12:13'!
encodeUint32: aSmallInteger 
	"Append to the receiver an Integer as the next 4 bytes."
	stream		
		nextPut: (aSmallInteger bitShift: -24);
		nextPut: ((aSmallInteger bitShift: -16) bitAnd: 255);
		nextPut: ((aSmallInteger bitShift: -8) bitAnd: 255);
		nextPut: (aSmallInteger bitAnd: 255)
! !

!FLEncoder methodsFor: 'encoding' stamp: 'MarianoMartinezPeck 6/8/2012 22:54'!
encodeUint8: aSmallInteger 
	"Append to the receiver an Integer as the next two bytes."
	stream nextPut: aSmallInteger ! !

!FLEncoder methodsFor: 'encoding' stamp: 'MartinDias 12/30/2011 15:34'!
encodeWeakReferenceTo: anObject

	indexStream 
		nextIndexPut: (objectsIndexes at: anObject ifAbsent: [objectsIndexes at: nil]) 
! !

!FLEncoder methodsFor: 'encoding' stamp: 'MartinDias 12/29/2011 20:18'!
encodeWords: aWordsObject
	stream nextWordsPut: aWordsObject! !

!FLEncoder methodsFor: 'encoding' stamp: 'MartinDias 12/30/2011 15:31'!
encodeYourself

	self encodePositiveInteger: objectCount.
	self encodePositiveInteger: Smalltalk isBigEndian asBit.! !

!FLEncoder methodsFor: 'initialize-release' stamp: 'MartinDias 1/6/2012 22:42'!
flush

	^ stream flush.! !

!FLEncoder methodsFor: 'hooks' stamp: 'MartinDias 5/11/2012 16:15'!
fuelAccept: aGeneralMapper
	^ aGeneralMapper visitSubstitution: self by: nil! !

!FLEncoder methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 8/19/2012 23:46'!
initializeOn: aStream 
	
	self initialize.
	stream := FLBufferedWriteStream on: aStream.! !

!FLEncoder methodsFor: 'accessing' stamp: 'MartinDias 12/29/2011 18:46'!
objectCount
	^ objectCount! !

!FLEncoder methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/20/2012 23:31'!
objectCount: aNumber

	objectCount := aNumber.
	objectsIndexes := FLLargeIdentityDictionary new.
	indexStream := FLIndexStream on: stream digits: aNumber digitLength.! !

!FLEncoder methodsFor: 'accessing' stamp: 'MartinDias 12/29/2011 17:12'!
objectsIndexes
	^ objectsIndexes! !

Object subclass: #FLHeader
	instanceVariableNames: 'preMaterializationActions additionalObjects postMaterializationActions materialization'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core'!

!FLHeader commentStamp: '<historical>' prior: 0!
An instance of FLHeader is serialized together with the orignal object graph to serialize. This header is useful to:

1) Attach additional state or metadata associated to the graph being serialized.
2) Attach pre and post materialization actions!

!FLHeader methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 7/28/2012 14:25'!
addPostMaterializationAction: aCleanBlockClosure
	"The closure may (or not) have one parameter and it will be the materialization."
	aCleanBlockClosure isClean ifFalse: [ self error: 'Post materializaton actions have to be clean closures. For more details see method BlocKClosure >> #isClean' ].
	postMaterializationActions add: aCleanBlockClosure ! !

!FLHeader methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 7/28/2012 14:24'!
addPreMaterializationAction: aCleanBlockClosure
	aCleanBlockClosure isClean ifFalse: [ self error: 'Pre materializaton actions have to be clean closures. For more details see method BlocKClosure >> #isClean' ].
	preMaterializationActions add: aCleanBlockClosure ! !

!FLHeader methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 7/28/2012 11:53'!
additionalObjectAt: key
	^ additionalObjects at: key! !

!FLHeader methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 7/28/2012 11:36'!
at: key putAdditionalObject: anObject 
	"This is useful if we want to attach objects to a package that will also be serialized. The way they are stored is key-value."
	additionalObjects at: key put: anObject! !

!FLHeader methodsFor: 'executing' stamp: 'MarianoMartinezPeck 7/28/2012 14:25'!
executePostMaterializationActions
	postMaterializationActions do: [:each | each cull: materialization]! !

!FLHeader methodsFor: 'executing' stamp: 'MarianoMartinezPeck 7/28/2012 14:25'!
executePreMaterializationActions
	preMaterializationActions do: [:each | each value]! !

!FLHeader methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 7/28/2012 12:33'!
initialize
	additionalObjects := IdentityDictionary new.
	preMaterializationActions := OrderedCollection new.
	postMaterializationActions := OrderedCollection new.! !

!FLHeader methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 7/28/2012 13:48'!
materialization: aMaterialization
	"This is just set once the materialization had happened"
	materialization := aMaterialization ! !

!FLHeader methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 8/21/2012 16:50'!
postMaterializationActions: listOfPostMaterializationActions
	postMaterializationActions := listOfPostMaterializationActions.
	! !

!FLHeader methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 8/21/2012 16:50'!
preMaterializationActions: listOfPreMaterializationActions
	preMaterializationActions := listOfPreMaterializationActions.
	! !

Object subclass: #FLIndexStream
	instanceVariableNames: 'stream digits'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Streams'!

!FLIndexStream commentStamp: '<historical>' prior: 0!
I am an optimized stream for writing and reading *indexes*, i.e. positive integers with a known upper bound. !

!FLIndexStream class methodsFor: 'instance creation' stamp: 'MartinDias 12/30/2011 14:33'!
on: aStream digits: aNumberOfDigits

	^ self basicNew 
		initializeOn: aStream 
		digits: aNumberOfDigits;
		yourself.

	! !

!FLIndexStream methodsFor: 'initialize-release' stamp: 'MartinDias 12/30/2011 14:28'!
initializeOn: aStream digits: aNumberOfDigits

	self initialize.
	stream := aStream.
	digits := aNumberOfDigits! !

!FLIndexStream methodsFor: 'accessing' stamp: 'MartinDias 12/30/2011 15:25'!
nextIndex
	
	| s |
	s := 0.
	1 to: digits do: 
		[:i | s := (s bitShift: 8) bitOr: stream next].
	^ s! !

!FLIndexStream methodsFor: 'accessing' stamp: 'MartinDias 12/30/2011 15:21'!
nextIndexPut: v

	1 to: digits do: [:i | stream nextPut: (v digitAt: digits + 1 - i)]
! !

Object subclass: #FLMapper
	instanceVariableNames: 'next analysis'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Mappers'!

!FLMapper commentStamp: 'MartinDias 8/11/2011 03:09' prior: 0!
The purpose of my hierarchy is to map objects with clusters.!

FLMapper subclass: #FLLightGeneralMapper
	instanceVariableNames: 'wellKnownObjectCluster globalInstanceSideCluster'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Mappers'!

!FLLightGeneralMapper commentStamp: '<historical>' prior: 0!
I know how to map an object to its default cluster. I can map every object.!

!FLLightGeneralMapper methodsFor: 'protected-mapping' stamp: 'MartinDias 1/9/2012 21:08'!
clusterClassForCharacter: aCharacter

	^ aCharacter isOctetCharacter 
		ifTrue: [ FLHookPrimitiveCluster ]
		ifFalse: [ FLFixedObjectCluster ]! !

!FLLightGeneralMapper methodsFor: 'protected-mapping' stamp: 'MarianoMartinezPeck 6/9/2012 11:58'!
clusterClassForSmallInteger: aSmallInteger

	aSmallInteger >= 0 ifTrue: [
		aSmallInteger <= 255 ifTrue: [^ FLPositive8SmallIntegerCluster].
		aSmallInteger <= 65535 ifTrue: [^ FLPositive16SmallIntegerCluster].
		aSmallInteger <= 16777215 ifTrue: [^ FLPositive24SmallIntegerCluster].
		aSmallInteger <= 4294967295 ifTrue: [^ FLPositive32SmallIntegerCluster].
	].
	aSmallInteger >= -128 ifTrue: [^ FLNegative8SmallIntegerCluster].
	aSmallInteger >= -32768 ifTrue: [^ FLNegative16SmallIntegerCluster].
	aSmallInteger >= -8388608 ifTrue: [^ FLNegative24SmallIntegerCluster].
	aSmallInteger >= -2147483648 ifTrue: [^ FLNegative32SmallIntegerCluster].

! !

!FLLightGeneralMapper methodsFor: 'mapping' stamp: 'MartinDias 1/8/2012 12:36'!
mapAndTrace: anObject

	anObject fuelAccept: self
! !

!FLLightGeneralMapper methodsFor: 'protected-mapping' stamp: 'MartinDias 1/9/2012 19:06'!
mapAndTraceInstanceSideGlobal: aClassOrTrait

	(globalInstanceSideCluster ifNil: [
		globalInstanceSideCluster := self clusterKeyedByClusterName: FLGlobalClassCluster ])
		add: aClassOrTrait traceWith: analysis
! !

!FLLightGeneralMapper methodsFor: 'visiting' stamp: 'MartinDias 1/9/2012 18:23'!
visitBytesObject: anObject

	self mapAndTraceByObjectClass: anObject to: FLByteObjectCluster! !

!FLLightGeneralMapper methodsFor: 'visiting' stamp: 'MartinDias 1/9/2012 21:08'!
visitCharacter: aCharacter

	self flag: #todo.	"confusing"
	self mapAndTraceByObjectClass: aCharacter to: (self clusterClassForCharacter: aCharacter)! !

!FLLightGeneralMapper methodsFor: 'visiting' stamp: 'MartinDias 1/8/2012 20:14'!
visitClass: aClass

	self mapAndTraceInstanceSideGlobal: aClass! !

!FLLightGeneralMapper methodsFor: 'visiting' stamp: 'MartinDias 1/9/2012 18:23'!
visitClassTrait: aClassTrait

	self mapAndTraceByClusterName: aClassTrait to: FLGlobalClassSideCluster! !

!FLLightGeneralMapper methodsFor: 'visiting' stamp: 'MartinDias 2/18/2013 19:05'!
visitCompiledMethod: aCompiledMethod
	(aCompiledMethod isInstalled not or: [aCompiledMethod isDoIt ])
		ifTrue: [ self mapAndTraceByClusterName: aCompiledMethod to: FLCompiledMethodCluster ]
		ifFalse: [self mapAndTraceByClusterName: aCompiledMethod to: FLGlobalCompiledMethodCluster]
		
	
	! !

!FLLightGeneralMapper methodsFor: 'visiting' stamp: 'MarianoMartinezPeck 7/26/2012 16:14'!
visitDictionary: aDictionary

	self mapAndTraceByObjectClass: aDictionary to: FLDictionaryCollectionCluster
! !

!FLLightGeneralMapper methodsFor: 'visiting' stamp: 'MartinDias 1/9/2012 18:23'!
visitFixedObject: anObject

	self mapAndTraceByObjectClass: anObject to: FLFixedObjectCluster! !

!FLLightGeneralMapper methodsFor: 'visiting' stamp: 'MarianoMartinezPeck 10/19/2012 22:49'!
visitGlobalSend: anObject name: globalName selector: aSymbol

	(self clusterKeyedByObjectClass: FLGlobalSendCluster class: anObject class)
		add: anObject name: globalName selector: aSymbol traceWith: analysis
! !

!FLLightGeneralMapper methodsFor: 'visiting' stamp: 'MartinDias 3/28/2012 21:19'!
visitHookPrimitive: anObject

	self mapAndTraceByObjectClass: anObject to: FLHookPrimitiveCluster
	! !

!FLLightGeneralMapper methodsFor: 'visiting' stamp: 'MartinDias 1/9/2012 18:23'!
visitMetaclass: aMetaclass

	self mapAndTraceByClusterName: aMetaclass to: FLGlobalClassSideCluster! !

!FLLightGeneralMapper methodsFor: 'visiting' stamp: 'MartinDias 1/9/2012 18:23'!
visitMethodContext: aMethodContext

	self mapAndTraceByObjectClass: aMethodContext to: FLMethodContextCluster
! !

!FLLightGeneralMapper methodsFor: 'visiting' stamp: 'MartinDias 5/18/2012 17:38'!
visitNotSerializable: anObject
	FLNotSerializable signalWith: anObject! !

!FLLightGeneralMapper methodsFor: 'visiting' stamp: 'MartinDias 1/9/2012 18:34'!
visitPoint: aPoint

	self mapAndTraceByClusterName: aPoint to: FLPointCluster! !

!FLLightGeneralMapper methodsFor: 'visiting' stamp: 'MartinDias 1/9/2012 18:34'!
visitRectangle: aRectangle

	self mapAndTraceByClusterName: aRectangle to: FLRectangleCluster! !

!FLLightGeneralMapper methodsFor: 'visiting' stamp: 'MarianoMartinezPeck 7/26/2012 17:41'!
visitSimpleCollection: aCollection
	self mapAndTraceByObjectClass: aCollection to: FLSimpleCollectionCluster
! !

!FLLightGeneralMapper methodsFor: 'visiting' stamp: 'MartinDias 1/9/2012 21:09'!
visitSmallInteger: aSmallInteger

	self mapAndTraceByClusterName: aSmallInteger to: (self clusterClassForSmallInteger: aSmallInteger)! !

!FLLightGeneralMapper methodsFor: 'visiting' stamp: 'MartinDias 1/9/2012 18:29'!
visitSubstitution: anObject by: anotherObject

	(self clusterKeyedByClusterName: FLSubstitutionCluster)
		add: anObject substitutedBy: anotherObject traceWith: analysis
! !

!FLLightGeneralMapper methodsFor: 'visiting' stamp: 'MartinDias 5/9/2012 01:05'!
visitSubstitution: anObject by: anotherObject onRecursionDo: aBlock

	| cluster |
	cluster := self clusterKeyedByClusterName: FLSubstitutionCluster.

	(cluster isSubstitute: anObject)
		ifTrue: aBlock
		ifFalse: [
			cluster
				add: anObject
				substitutedBy: anotherObject
				traceWith: analysis ]
! !

!FLLightGeneralMapper methodsFor: 'visiting' stamp: 'MartinDias 1/8/2012 20:14'!
visitTrait: aTrait

	self mapAndTraceInstanceSideGlobal: aTrait! !

!FLLightGeneralMapper methodsFor: 'visiting' stamp: 'MartinDias 1/9/2012 18:23'!
visitVariableObject: anObject

	self mapAndTraceByObjectClass: anObject to: FLVariableObjectCluster! !

!FLLightGeneralMapper methodsFor: 'visiting' stamp: 'MartinDias 1/9/2012 18:23'!
visitWeakObject: anObject

	self mapAndTraceByObjectClass: anObject to: FLWeakVariableObjectCluster! !

!FLLightGeneralMapper methodsFor: 'visiting' stamp: 'MartinDias 1/9/2012 18:35'!
visitWellKnownObject: anObject

	wellKnownObjectCluster ifNil: [
		wellKnownObjectCluster := self clusterKeyedByClusterName: FLWellKnownObjectsCluster ]
	"Note: It is not necessary to explicitly add objects to this cluster"
! !

!FLLightGeneralMapper methodsFor: 'visiting' stamp: 'MartinDias 1/9/2012 18:23'!
visitWordsObject: anObject

	self mapAndTraceByObjectClass: anObject to: FLWordObjectCluster! !

FLMapper subclass: #FLLightGlobalMapper
	instanceVariableNames: 'globals'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Mappers'!

!FLLightGlobalMapper commentStamp: '<historical>' prior: 0!
I map classes, traits, and global objects that belong to Smalltalk dictionary. I collaborate in serialization default behavior. 

For example, the global Transcript as well as any class in the image, are mapped by me.!

!FLLightGlobalMapper class methodsFor: 'instance creation' stamp: 'MartinDias 12/30/2011 19:33'!
for: globalSymbols

	^ self basicNew
		initializeWith: (self valuesFor: globalSymbols);
		yourself.! !

!FLLightGlobalMapper class methodsFor: 'private' stamp: 'MarianoMartinezPeck 4/17/2012 16:41'!
valuesFor: globalSymbols

	"Some globals, like ActiveHand have a nil value in the Smalltalk globals. Therefore, we cannot map nil to globalCluster. We could filter before in #defaultGlobalSymbols but that means that not even the Association will be consider global."
	^ (globalSymbols select: [:each | (Smalltalk globals at: each) isNil not ])
		collect: [:aSymbol | Smalltalk globals at: aSymbol] 
		as: IdentitySet! !

!FLLightGlobalMapper methodsFor: 'initialize-release' stamp: 'MartinDias 1/9/2012 18:11'!
initializeWith: someObjects

	self initialize.
	globals := someObjects.! !

!FLLightGlobalMapper methodsFor: 'mapping' stamp: 'MartinDias 1/9/2012 18:36'!
mapAndTrace: anObject
	"Uses the Chain of Responsibility pattern to answer the cluster which maps with the received object."

	(globals includes: anObject) 
		ifTrue: [ self mapAndTraceByClusterName: anObject to: FLGlobalValueCluster ]
		ifFalse: [ next mapAndTrace: anObject ]! !

!FLMapper methodsFor: 'accessing' stamp: 'MartinDias 1/8/2012 18:40'!
analysis: anAnalysis

	analysis := anAnalysis.
	next isNil ifFalse: [ next analysis: anAnalysis ]! !

!FLMapper methodsFor: 'protected-mapping' stamp: 'MartinDias 1/8/2012 20:45'!
clusterInstanceOf: aClusterClass keyInBucket: clusterKey factory: clusterFactory

	| bucket |
	bucket := aClusterClass clusterBucketIn: analysis clusterization.
	^ bucket
		at: clusterKey
		ifAbsentPut: [ 
			clusterFactory value 
				traceWith: analysis;
				yourself ].
! !

!FLMapper methodsFor: 'protected-mapping' stamp: 'MartinDias 1/9/2012 18:29'!
clusterKeyedByClusterName: aClusterClass

	^ self
		clusterKeyedByClusterName: aClusterClass 
		factory:  [ aClusterClass newAnalyzing ]! !

!FLMapper methodsFor: 'protected-mapping' stamp: 'MartinDias 1/9/2012 18:29'!
clusterKeyedByClusterName: aClusterClass factory: clusterFactory

	^ self
		clusterInstanceOf: aClusterClass
		keyInBucket: aClusterClass name
		factory: clusterFactory
! !

!FLMapper methodsFor: 'protected-mapping' stamp: 'MartinDias 1/9/2012 18:27'!
clusterKeyedByObjectClass: clusterClass class: objectClass

	^ self 
		clusterInstanceOf: clusterClass 
		keyInBucket: objectClass 
		factory: [ clusterClass newAnalyzing: objectClass ]! !

!FLMapper methodsFor: 'hooks' stamp: 'MartinDias 3/29/2012 03:05'!
fuelAccept: aGeneralMapper
	^ aGeneralMapper visitSubstitution: self by: nil! !

!FLMapper methodsFor: 'mapping' stamp: 'MartinDias 1/8/2012 12:38'!
mapAndTrace: anObject

	self subclassResponsibility! !

!FLMapper methodsFor: 'protected-mapping' stamp: 'MartinDias 1/9/2012 18:29'!
mapAndTraceByClusterName: anObject to: aClusterClass

	(self clusterKeyedByClusterName: aClusterClass)
		add: anObject traceWith: analysis
! !

!FLMapper methodsFor: 'protected-mapping' stamp: 'MartinDias 1/9/2012 18:28'!
mapAndTraceByObjectClass: anObject to: aClusterClass

	(self clusterKeyedByObjectClass: aClusterClass class: anObject class)
		add: anObject traceWith: analysis
! !

!FLMapper methodsFor: 'accessing' stamp: 'MartinDias 8/7/2011 17:19'!
next: anObject
	next := anObject! !

FLMapper subclass: #FLPluggableSubstitutionMapper
	instanceVariableNames: 'condition substitutionFactory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Mappers'!

!FLPluggableSubstitutionMapper commentStamp: 'MartinDias 8/20/2011 23:45' prior: 0!
I map substituted objects. 

For example, suppose you want to substitute instances of WriteStream by nil. In such case, I will map every WriteStream instance to my substitutions cluster, and its factory block will value to nil with any argument.
!

!FLPluggableSubstitutionMapper class methodsFor: 'instance creation' stamp: 'MartinDias 1/9/2012 14:52'!
when: aCondition substituteBy: aFactory

	^self basicNew
		initializeWith: aCondition 
		substitutionFactory: aFactory;
		yourself! !

!FLPluggableSubstitutionMapper methodsFor: 'initialize-release' stamp: 'MartinDias 1/9/2012 14:53'!
initializeWith: aCondition substitutionFactory: aBlock

	self initialize.
	condition := aCondition.
	substitutionFactory := aBlock.! !

!FLPluggableSubstitutionMapper methodsFor: 'mapping' stamp: 'MartinDias 5/9/2012 00:12'!
mapAndTrace: anObject
	"Uses the Chain of Responsibility pattern to answer the cluster which maps with the received object."

	(condition value: anObject)
		ifTrue: [ self mapAndTraceSubstitutionIfNotRecursive: anObject ]
		ifFalse: [ next mapAndTrace: anObject ]! !

!FLPluggableSubstitutionMapper methodsFor: 'mapping' stamp: 'MartinDias 5/9/2012 00:13'!
mapAndTraceSubstitutionIfNotRecursive: anObject
		
	| cluster |
	cluster := self clusterKeyedByClusterName: FLSubstitutionCluster.

	(cluster isSubstitute: anObject)
		ifTrue: [ next mapAndTrace: anObject ]
		ifFalse: [
			cluster
				add: anObject
				substitutedBy: (substitutionFactory value: anObject)
				traceWith: analysis ]
! !

Object subclass: #FLMaterialization
	instanceVariableNames: 'clusterCount clusters root decoder header'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core'!

!FLMaterialization commentStamp: 'MarianoMartinezPeck 10/23/2011 14:42' prior: 0!
I implement the algorithm for materializing an object graph on a stream. FLMaterializer known how to build instances of me.!

!FLMaterialization class methodsFor: 'instance creation' stamp: 'MartinDias 1/5/2012 14:29'!
with: aDecoder

	^self basicNew
		initializeWith: aDecoder;
		yourself
! !

!FLMaterialization methodsFor: 'header' stamp: 'MarianoMartinezPeck 7/28/2012 13:47'!
additionalObjectAt: aKey
	^ header additionalObjectAt: aKey! !

!FLMaterialization methodsFor: 'private' stamp: 'MartinDias 12/29/2011 18:09'!
afterMaterializationStep

	clusters do: [ :aCluster | aCluster afterMaterializationStepWith: decoder ]! !

!FLMaterialization methodsFor: 'private' stamp: 'MarianoMartinezPeck 9/19/2012 14:38'!
clusterInstancesStep

	| aCluster |
	aCluster := decoder nextEncodedClusterClass newMaterializing.
	aCluster clusterMaterializeStepWith: self.
	aCluster materializeInstancesStepWith: decoder.
	self registerAll: aCluster objects.
	aCluster materializePostInstancesStepWith: decoder.
	clusters add: aCluster.! !

!FLMaterialization methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 9/19/2012 14:36'!
decoder
	^ decoder! !

!FLMaterialization methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 7/28/2012 13:46'!
header: aHeader
	header := aHeader
	! !

!FLMaterialization methodsFor: 'private' stamp: 'MartinDias 12/29/2011 18:27'!
headerStep

	decoder decodeYourself.
	clusterCount := decoder nextEncodedPositiveInteger.
	clusters := OrderedCollection new: clusterCount.
	clusters resetTo: 1. "Hack that avoids OrderedCollection>>makeRoomAtLast"! !

!FLMaterialization methodsFor: 'initialize-release' stamp: 'MartinDias 1/5/2012 14:30'!
initializeWith: aDecoder

	self initialize.
	decoder := aDecoder.
! !

!FLMaterialization methodsFor: 'private' stamp: 'MartinDias 9/9/2011 01:58'!
instancesStep

	clusterCount timesRepeat: [ self clusterInstancesStep ]
! !

!FLMaterialization methodsFor: 'accessing' stamp: 'MartinDias 12/29/2011 18:12'!
objects
	"Answer a collection with the materialized objects."

	^ decoder objects ! !

!FLMaterialization methodsFor: 'private' stamp: 'MartinDias 12/29/2011 18:11'!
referencesStep

	clusters do: [ :aCluster | aCluster materializeReferencesStepWith: decoder ]! !

!FLMaterialization methodsFor: 'private' stamp: 'MartinDias 12/29/2011 18:25'!
registerAll: materializedObjects
	
	decoder registerAll: materializedObjects ! !

!FLMaterialization methodsFor: 'accessing' stamp: 'MartinDias 9/9/2011 01:58'!
root

	^ root ! !

!FLMaterialization methodsFor: 'materializing' stamp: 'MarianoMartinezPeck 9/27/2011 16:50'!
run

	self headerStep.
	self instancesStep.
	self referencesStep.
	self trailerStep.
	self afterMaterializationStep.! !

!FLMaterialization methodsFor: 'private' stamp: 'MartinDias 12/29/2011 18:11'!
trailerStep

	root := decoder nextEncodedReference! !

Object subclass: #FLMaterializer
	instanceVariableNames: 'materializationFactory signature version migrations'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core'!

!FLMaterializer commentStamp: 'MartinDias 8/29/2011 19:06' prior: 0!
I am a binary object materializer. 

See an example of use in FLSerializer's documentation.

!

!FLMaterializer class methodsFor: 'protected' stamp: 'MartinDias 5/18/2012 15:26'!
currentVersion
	"If you change this method, you should also create a version in ConfigurationOfFuel and FLSerializer >> currentVersion"
	^ 18! !

!FLMaterializer class methodsFor: 'protected' stamp: 'MartinDias 10/6/2011 23:31'!
defaultSignature
	^ 'FUEL'! !

!FLMaterializer class methodsFor: 'materializing-shortcuts' stamp: 'MarianoMartinezPeck 9/27/2011 17:14'!
materializationFromFileNamed: aFilename

	^StandardFileStream 
		oldFileNamed: aFilename 
		do: [:aFileStream | 
			(self newDefault materializeFrom: aFileStream binary) ]
! !

!FLMaterializer class methodsFor: 'materializing-shortcuts' stamp: 'MarianoMartinezPeck 7/28/2012 14:57'!
materializationHeaderFromFileNamed: aFilename

	^StandardFileStream 
		oldFileNamed: aFilename 
		do: [:aFileStream | 
			(self newDefault materializeHeaderFrom: aFileStream binary) ]
! !

!FLMaterializer class methodsFor: 'materializing-shortcuts' stamp: 'MartinDias 9/9/2011 20:25'!
materializeFromByteArray: byteArray

	^(self newDefault materializeFrom: byteArray readStream) root! !

!FLMaterializer class methodsFor: 'materializing-shortcuts' stamp: 'MarianoMartinezPeck 9/27/2011 17:15'!
materializeFromFileNamed: aFilename

	^ (self materializationFromFileNamed: aFilename) root
! !

!FLMaterializer class methodsFor: 'materializing-shortcuts' stamp: 'MarianoMartinezPeck 7/28/2012 14:58'!
materializeHeaderFromFileNamed: aFilename

	^ self materializationHeaderFromFileNamed: aFilename
! !

!FLMaterializer class methodsFor: 'instance creation' stamp: 'MartinDias 9/10/2011 18:16'!
newDefault

	^self new! !

!FLMaterializer methodsFor: 'hooks' stamp: 'MartinDias 3/29/2012 03:05'!
fuelAccept: aGeneralMapper
	^ aGeneralMapper visitSubstitution: self by: nil! !

!FLMaterializer methodsFor: 'initialize-release' stamp: 'MartinDias 1/7/2012 00:37'!
initialize

	super initialize.
	self setDefaultMaterialization.
	self signature: self class defaultSignature.
	self version: self class currentVersion.
	migrations := Dictionary new.! !

!FLMaterializer methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 7/29/2012 23:31'!
materializationFactory
	^ materializationFactory! !

!FLMaterializer methodsFor: 'materializing' stamp: 'MarianoMartinezPeck 7/31/2012 11:21'!
materializeFrom: aStream

	| aDecoder materialization header |
	aDecoder := FLDecoder on: aStream migrations: migrations.
	self verifySignatureFrom: aDecoder.
	self verifyVersionFrom: aDecoder.
	"Here I cannot use #materializeFrom: again because I will end up in an infinitive loop. Therefore, I use #materializationFactory."
	header := (FLMaterializer newDefault materializationFactory value: aDecoder) root.
	header executePreMaterializationActions.
	materialization := materializationFactory value: aDecoder.
	"This is useful because when the user materialize something, what it is answered is the materialization objet, and not the materializer. Hence, it is difficult to query the header (like asking the additionalObjects) because materializer is lost. Therefore, we also set the header to the materialization."
	materialization header: header. 
	"This is useful because the postMaterializationActions may need to have access to the state of the materialization, for example, to the root"
	header materialization: materialization.
	header executePostMaterializationActions.
	^ materialization 
	! !

!FLMaterializer methodsFor: 'materializing' stamp: 'MarianoMartinezPeck 7/28/2012 14:55'!
materializeHeaderFrom: aStream

	| aDecoder materialization header |
	aDecoder := FLDecoder on: aStream migrations: migrations.
	self verifySignatureFrom: aDecoder.
	self verifyVersionFrom: aDecoder.
	^ (materializationFactory value: aDecoder) root.
	! !

!FLMaterializer methodsFor: 'configuring-migration' stamp: 'MartinDias 1/5/2012 01:04'!
migrateClassNamed: aSymbol toClass: aClass

	self 
		migrateClassNamed: aSymbol 
		toClass: aClass 
		variables: #()! !

!FLMaterializer methodsFor: 'configuring-migration' stamp: 'MartinDias 5/18/2012 18:56'!
migrateClassNamed: aSymbol toClass: aClass variables: aDictionary 

	migrations
		at: aSymbol
		put: (FLMigration fromClassNamed: aSymbol toClass: aClass variables: aDictionary)! !

!FLMaterializer methodsFor: 'configuring-migration' stamp: 'MartinDias 1/4/2012 23:52'!
migrateClassNamed: aSymbol variables: aDictionary 

	self 
		migrateClassNamed: aSymbol 
		toClass: (Smalltalk globals at: aSymbol)
		variables: aDictionary! !

!FLMaterializer methodsFor: 'protected' stamp: 'MartinDias 1/6/2012 20:34'!
setDefaultMaterialization

	materializationFactory := [:aDecoder | 
		(FLMaterialization 
			with: aDecoder)
			run; 
			yourself ]
	
	
! !

!FLMaterializer methodsFor: 'accessing' stamp: 'MartinDias 10/6/2011 22:57'!
signature
	^ signature! !

!FLMaterializer methodsFor: 'accessing' stamp: 'MartinDias 10/6/2011 22:57'!
signature: anObject
	signature := anObject! !

!FLMaterializer methodsFor: 'protected' stamp: 'MartinDias 1/7/2012 12:21'!
verifySignatureFrom: aDecoder

	| streamSignature |
	streamSignature := ByteArray new: self signature size.
	aDecoder nextEncodedBytesInto: streamSignature.
	(self signature asByteArray = streamSignature) ifFalse: [ 
		FLBadSignature 
			signalCurrentSignature: self signature 
			streamSignature: streamSignature  ].
! !

!FLMaterializer methodsFor: 'protected' stamp: 'MartinDias 1/7/2012 12:13'!
verifyVersionFrom: aDecoder

	| streamVersion |
	streamVersion := aDecoder nextEncodedUint16.
	(self version = streamVersion) ifFalse: [ 
		FLBadVersion 
			signalCurrentVersion: self version 
			streamVersion: streamVersion ]
! !

!FLMaterializer methodsFor: 'accessing' stamp: 'MartinDias 10/6/2011 22:57'!
version
	^ version! !

!FLMaterializer methodsFor: 'accessing' stamp: 'MartinDias 10/6/2011 22:57'!
version: anObject
	version := anObject! !

Object subclass: #FLMigration
	instanceVariableNames: 'sourceClassName variables targetClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core'!

!FLMigration commentStamp: 'MartinDias 1/6/2012 16:04' prior: 0!
I represent migration information about a class.

See 'configuring-migration' protocol in FLMaterializer.!

!FLMigration class methodsFor: 'instance creation' stamp: 'MartinDias 1/4/2012 23:57'!
fromClassNamed: aSymbol toClass: aClass variables: anArray 

	^self basicNew
		initializeClassNamed: aSymbol 
		toClass: aClass 
		variables: anArray;
		yourself.! !

!FLMigration methodsFor: 'evaluating' stamp: 'MartinDias 1/5/2012 13:14'!
applyTo: aVariablesMapping 
	
	variables do: [:link |
		aVariablesMapping 
			map: link key 
			to: link value ]
	! !

!FLMigration methodsFor: 'initializing' stamp: 'MartinDias 1/5/2012 13:12'!
initializeClassNamed: aSymbol toClass: aClass variables: anArray 
	
	self initialize.
	sourceClassName := aSymbol.
	targetClass := aClass.
	variables := anArray.! !

!FLMigration methodsFor: 'accessing' stamp: 'MartinDias 1/5/2012 01:09'!
sourceClassName

	^ sourceClassName! !

!FLMigration methodsFor: 'accessing' stamp: 'MartinDias 1/5/2012 13:12'!
targetClass

	^ targetClass! !

Object subclass: #FLSerialization
	instanceVariableNames: 'encoder root clusters analyzer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core'!

!FLSerialization commentStamp: 'MarianoMartinezPeck 10/23/2011 14:42' prior: 0!
I implement the algorithm for serializing an object graph on a stream. FLSerializer known how to build instances of me.!

!FLSerialization class methodsFor: 'instance creation' stamp: 'MartinDias 1/5/2012 14:34'!
with: anEncoder root: anObject analyzer: anAnalyzer
	
	^ self basicNew
		initializeWith: anEncoder
		root: anObject
		analyzer: anAnalyzer;
		yourself! !

!FLSerialization methodsFor: 'private' stamp: 'MartinDias 12/29/2011 17:06'!
analysisStep

	| anAnalysis |
	anAnalysis := analyzer analysisFor: root.
	clusters := anAnalysis clusterization clusters.
	encoder objectCount: anAnalysis clusterization objectCount.
! !

!FLSerialization methodsFor: 'private' stamp: 'MarianoMartinezPeck 9/19/2012 14:40'!
clusterInstancesStepOf: aCluster

	encoder encodeClusterClass: aCluster class.
	aCluster clusterSerializeStepWith: self.
	aCluster serializeInstancesStepWith: encoder.
	aCluster serializePostInstancesStepWith: encoder.
! !

!FLSerialization methodsFor: 'accessing' stamp: 'MartinDias 9/13/2011 16:34'!
clusters
	^ clusters! !

!FLSerialization methodsFor: 'accessing' stamp: 'MartinDias 12/29/2011 16:55'!
encoder
	^ encoder! !

!FLSerialization methodsFor: 'hooks' stamp: 'MartinDias 3/29/2012 03:05'!
fuelAccept: aGeneralMapper
	^ aGeneralMapper visitSubstitution: self by: nil! !

!FLSerialization methodsFor: 'private' stamp: 'MartinDias 12/29/2011 18:28'!
headerStep
	
	encoder encodeYourself.
	encoder encodePositiveInteger: clusters size.! !

!FLSerialization methodsFor: 'initialize-release' stamp: 'MartinDias 1/5/2012 14:34'!
initializeWith: anEncoder root: anObject analyzer: anAnalyzer
			
	self initialize.
	encoder := anEncoder.
	root := anObject.
	analyzer := anAnalyzer.! !

!FLSerialization methodsFor: 'private' stamp: 'MartinDias 1/6/2012 12:24'!
instancesStep

	clusters do: [ :aCluster | aCluster registerIndexesOn: encoder objectsIndexes ].
	clusters do: [ :aCluster | self clusterInstancesStepOf: aCluster ]! !

!FLSerialization methodsFor: 'accessing' stamp: 'MartinDias 1/6/2012 12:24'!
objects
	"Answer a collection with the serialized objects."

	^ encoder objectsIndexes keys! !

!FLSerialization methodsFor: 'private' stamp: 'MartinDias 12/29/2011 18:06'!
referencesStep

	clusters do: [ :aCluster | aCluster serializeReferencesStepWith: encoder ]! !

!FLSerialization methodsFor: 'accessing' stamp: 'MartinDias 9/9/2011 01:33'!
root
	^ root! !

!FLSerialization methodsFor: 'serializing' stamp: 'MarianoMartinezPeck 7/26/2012 16:04'!
run
	"Serialize the graph starting at the root object."

	self analysisStep.
	self headerStep.
	self instancesStep.
	self referencesStep.
	self trailerStep.! !

!FLSerialization methodsFor: 'private' stamp: 'MartinDias 12/29/2011 17:07'!
trailerStep

	encoder encodeReferenceTo: root! !

Object subclass: #FLSerializer
	instanceVariableNames: 'analyzer serializationFactory signature version stream header'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core'!

!FLSerializer commentStamp: 'MartinDias 8/29/2011 19:10' prior: 0!
I am a binary object serializer.

An example of use:

| sourceArray loadedArray |
sourceArray := 
	Array 
		with: 'a string' 
		with: Transcript
		with: [ Transcript show: 'a string' ].

"Store to the file"
FLSerializer serialize: sourceArray toFileNamed: 'example.FL'. 

"Load from the file"
loadedArray := FLMaterializer materializeFromFileNamed: 'example.FL'. 

"The arrays are not the same"
[ sourceArray ~~ loadedArray ] assert.

"The strings are not the same"
[ sourceArray first ~~ loadedArray first ] assert.
[ sourceArray first = loadedArray first ] assert.

"The global instance Transcript is the same"
[ sourceArray second == loadedArray second ] assert.

"Appreciate in Transcript that the loaded block prints a string"
loadedArray third value.
!

!FLSerializer class methodsFor: 'protected' stamp: 'MartinDias 5/18/2012 15:26'!
currentVersion
	"If you change this method, you should also create a version in ConfigurationOfFuel and FLMaterializer >> currentVersion"
	^ 18! !

!FLSerializer class methodsFor: 'protected' stamp: 'MartinDias 10/6/2011 23:28'!
defaultSignature
	^ 'FUEL'! !

!FLSerializer class methodsFor: 'instance creation' stamp: 'MartinDias 9/25/2011 20:12'!
newDefault

	^self newLight! !

!FLSerializer class methodsFor: 'instance creation' stamp: 'MartinDias 9/25/2011 20:12'!
newLight

	^self new! !

!FLSerializer class methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 5/30/2012 21:48'!
on: aStream
	^ self newLight 
		stream: aStream;
		yourself! !

!FLSerializer class methodsFor: 'serializing-shortcuts' stamp: 'MarianoMartinezPeck 5/11/2012 16:23'!
serialize: anObject on: aStream

	self newDefault serialize: anObject on: aStream! !

!FLSerializer class methodsFor: 'serializing-shortcuts' stamp: 'mada 5/10/2012 20:56'!
serialize: anObject toFileNamed: aFilename

	self newDefault serialize: anObject toFileNamed: aFilename! !

!FLSerializer class methodsFor: 'serializing-shortcuts' stamp: 'MartinDias 1/11/2012 00:45'!
serializeToByteArray: anObject
	"No stream is needed by the user. An internal in-memory stream will be used. This method returns a ByteArray representing the serialization"

	| aStream |
	aStream := WriteStream on: (ByteArray new: 100).
	self newDefault serialize: anObject on: aStream.
	^ aStream contents! !

!FLSerializer methodsFor: 'header' stamp: 'MarianoMartinezPeck 7/28/2012 12:32'!
addPostMaterializationAction: aCleanBlockClosure
	header addPostMaterializationAction: aCleanBlockClosure! !

!FLSerializer methodsFor: 'header' stamp: 'MarianoMartinezPeck 7/28/2012 11:38'!
addPreMaterializationAction: aCleanBlockClosure
	header addPreMaterializationAction: aCleanBlockClosure! !

!FLSerializer methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/3/2011 16:18'!
analyzer
	analyzer isNil ifTrue: [ analyzer := self defaultAnalyzer ].
	^ analyzer! !

!FLSerializer methodsFor: 'accessing' stamp: 'MartinDias 8/20/2011 17:33'!
analyzer: anObject
	analyzer := anObject! !

!FLSerializer methodsFor: 'header' stamp: 'MarianoMartinezPeck 7/28/2012 11:38'!
at: key putAdditionalObject: anObject 
	"This is useful if we want to attach objects to a package that will also be serialized. The way they are stored is key-value."
	header at: key putAdditionalObject: anObject ! !

!FLSerializer methodsFor: 'protected' stamp: 'MartinDias 9/13/2011 19:26'!
defaultAnalyzer

	^FLAnalyzer newDefault! !

!FLSerializer methodsFor: 'protected' stamp: 'MartinDias 1/7/2012 12:07'!
encodeSignatureWith: anEncoder
	anEncoder encodeBytes: self signature asByteArray! !

!FLSerializer methodsFor: 'protected' stamp: 'MartinDias 1/7/2012 12:07'!
encodeVersionWith: anEncoder
	anEncoder encodeUint16: self version
! !

!FLSerializer methodsFor: 'hooks' stamp: 'MartinDias 3/29/2012 03:05'!
fuelAccept: aGeneralMapper
	^ aGeneralMapper visitSubstitution: self by: nil! !

!FLSerializer methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 8/21/2012 16:49'!
header
	^ header! !

!FLSerializer methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 7/28/2012 11:37'!
initialize

	super initialize.
	self signature: self class defaultSignature.
	self version: self class currentVersion.
	header := FLHeader new.! !

!FLSerializer methodsFor: 'protected' stamp: 'MartinDias 1/6/2012 20:31'!
serializationFactory

	^ serializationFactory ifNil: [ 
		self setDefaultSerialization.
		serializationFactory ].! !

!FLSerializer methodsFor: 'serializing' stamp: 'MarianoMartinezPeck 5/30/2012 21:49'!
serialize: anObject
	"Serialize the graph starting at the root object received and answers the FLSerialization object"

	^ self serialize: anObject on: stream! !

!FLSerializer methodsFor: 'serializing' stamp: 'MarianoMartinezPeck 7/31/2012 11:24'!
serialize: anObject on: aStream
	"Serialize the graph starting at the root object received and answers the FLSerialization object"

	FLEncoder
		on: aStream 
		do: [ :anEncoder | 
			self encodeSignatureWith: anEncoder.
			self encodeVersionWith: anEncoder.
			"For the moment, we serialize the header as light. Not sure how well it will work because the header can have closures... but Fuel core cannot serialize methods fully...so... "
			FLSerializer newDefault serializationFactory value: header value: anEncoder.
			^ self serializationFactory value: anObject value: anEncoder ]! !

!FLSerializer methodsFor: 'serializing' stamp: 'MarianoMartinezPeck 8/19/2012 23:57'!
serialize: anObject toFileNamed: aFilename
	"Serialize the graph starting at the root object received and answers the FLSerialization object"
	StandardFileStream 
		forceNewFileNamed: aFilename 
		do: [ :aFileStream |
			aFileStream binary. 
			self serialize: anObject on: aFileStream ]
	! !

!FLSerializer methodsFor: 'protected' stamp: 'MartinDias 1/6/2012 20:31'!
setDefaultSerialization

	^ serializationFactory := [:anObject :anEncoder | 
		(FLSerialization 
			with: anEncoder
			root: anObject 
			analyzer: self analyzer)
			run;
			yourself ]! !

!FLSerializer methodsFor: 'accessing' stamp: 'MartinDias 10/6/2011 22:56'!
signature
	^ signature! !

!FLSerializer methodsFor: 'accessing' stamp: 'MartinDias 10/6/2011 22:56'!
signature: anObject
	signature := anObject! !

!FLSerializer methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 5/30/2012 21:50'!
stream: aStream
	stream := aStream! !

!FLSerializer methodsFor: 'accessing' stamp: 'MartinDias 10/6/2011 22:56'!
version
	^ version! !

!FLSerializer methodsFor: 'accessing' stamp: 'MartinDias 10/6/2011 22:56'!
version: anObject
	version := anObject! !

Object subclass: #FLSimpleStack
	instanceVariableNames: 'array slotIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Collections'!

!FLSimpleStack commentStamp: 'MarianoMartinezPeck 6/5/2011 12:29' prior: 0!
FLSimpleStack is a simple stack used in Fuel to avoid a recursion while traversing the graph to serialize. While analizing the content of an object (inst vars) we can encounter simple objects (direct string representation) or complex objects (composite). In the latter case we start analizing those instVars.

So... Imagine object X with two instVars Y and Z. Imagine the method of the traverse is called #analye:.  So you do #analize: X.  Then, in such method you check whether X has regular pointers to regular objects, and if true, you analize them. So in this case you would send #analyze: Y and #analize: Z, generating the recursion. Right ?  Notice that the time between analyse: Y and analyse: Z is dependent on the graph that is attached to Y. Y can have objects that have further objects etc. So leaving X aside, Y can be the first object to serialize and Z the last.

With this FLSimpleStack, instead of sending #analyze: Y and #analize: Z  what Fuel does is just to do a push on a stack:   #push: Y  and #push: Z. And then we are done with X, so we pop from the stack and we continue with the next object (at some point in the future we will pop Y and Z) When there are no more objects in the stack it means we are done. !

!FLSimpleStack class methodsFor: 'instance creation' stamp: 'MartinDias 5/15/2011 23:11'!
hintSize

	^64! !

!FLSimpleStack class methodsFor: 'instance creation' stamp: 'MartinDias 5/15/2011 23:11'!
new
	
	^ self new: self hintSize! !

!FLSimpleStack class methodsFor: 'instance creation' stamp: 'MartinDias 5/15/2011 23:09'!
new: nElements
	"Create a Set large enough to hold nElements without growing"
	^ self basicNew initialize: nElements! !

!FLSimpleStack methodsFor: 'accessing' stamp: 'MartinDias 5/15/2011 23:08'!
capacity

	^ array size! !

!FLSimpleStack methodsFor: 'adding' stamp: 'MartinDias 5/15/2011 23:15'!
grow
	"Become larger in capacity."
	| newArray |
	newArray := Array new: array size * 2.
	newArray replaceFrom: 1 to: array size with: array startingAt: 1.
	array := newArray! !

!FLSimpleStack methodsFor: 'initialize-release' stamp: 'MartinDias 5/15/2011 23:10'!
initialize: hintSize

	array := Array new: hintSize.
	slotIndex := 1.! !

!FLSimpleStack methodsFor: 'accessing' stamp: 'MartinDias 5/15/2011 22:54'!
isEmpty

	^ 1 = slotIndex! !

!FLSimpleStack methodsFor: 'removing' stamp: 'MartinDias 5/15/2011 22:52'!
pop
	"Returns the first element and remove it from the stack."

	slotIndex := slotIndex - 1.	
	^ array at: slotIndex ! !

!FLSimpleStack methodsFor: 'printing' stamp: 'MartinDias 6/3/2011 20:25'!
printOn: aStream 
	"Append a sequence of characters that identify the receiver to aStream."

	super printOn: aStream.
	array printElementsOn: aStream
! !

!FLSimpleStack methodsFor: 'adding' stamp: 'MartinDias 5/15/2011 22:44'!
push: anObject 
	"Adds a new object of any kind on top of the stack."

	array at: slotIndex put: anObject.
	array size = slotIndex ifTrue: [ self grow ].
	slotIndex := slotIndex + 1.
	^ anObject.! !

Object subclass: #FLVariablesMapping
	instanceVariableNames: 'mapping theClass notIgnoredVariables'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Clusters'!

!FLVariablesMapping commentStamp: 'MartinDias 8/1/2011 03:01' prior: 0!
I am used to materialize instance variables in an object, tolerating "class shape changing".

Cases tolerated are:
- instance variable added
- instance variable order change
- instance variable removed
!

!FLVariablesMapping class methodsFor: 'instance creation' stamp: 'MartinDias 1/7/2012 11:54'!
materializing: aClass from: aDecoder
	
	^ self basicNew
		initializeWith: aClass;
		initializeMaterializingFrom: aDecoder;
		yourself.! !

!FLVariablesMapping class methodsFor: 'instance creation' stamp: 'MartinDias 1/8/2012 14:42'!
newAnalyzing: aClass
	
	^ self basicNew
		initializeWith: aClass;
		initializeAnalyzing;
		yourself.! !

!FLVariablesMapping methodsFor: 'serialize/materialize' stamp: 'MartinDias 1/8/2012 14:42'!
initializeAnalyzing

	notIgnoredVariables := self instanceVariableNamesToSerialize.
	
	mapping := notIgnoredVariables 
		collect: [ :name | theClass instVarIndexFor: name ].! !

!FLVariablesMapping methodsFor: 'serialize/materialize' stamp: 'MartinDias 1/7/2012 11:54'!
initializeMaterializingFrom: aDecoder

	notIgnoredVariables := (1 to: aDecoder nextEncodedByte) collect: [ :index | aDecoder nextEncodedString ].

	mapping := notIgnoredVariables  
		collect: [ :name | theClass instVarIndexFor: name ifAbsent: [ nil ] ].

! !

!FLVariablesMapping methodsFor: 'initialize-release' stamp: 'MartinDias 12/22/2011 14:41'!
initializeWith: aClass
	self initialize.
	theClass := aClass! !

!FLVariablesMapping methodsFor: 'private' stamp: 'MartinDias 12/22/2011 15:24'!
instanceVariableNamesToSerialize

	| ignoredInstanceVariableNames instanceVariableNamesToSerialize |
	ignoredInstanceVariableNames := theClass fuelIgnoredInstanceVariableNames.
	instanceVariableNamesToSerialize := OrderedCollection new.

	theClass instanceVariableNamesDo: [:name | 
		(ignoredInstanceVariableNames includes: name) 
			ifFalse: [ instanceVariableNamesToSerialize add: name ]].

	^ instanceVariableNamesToSerialize! !

!FLVariablesMapping methodsFor: 'accessing' stamp: 'MartinDias 1/11/2012 00:22'!
map: sourceName to: destinationName

	| indexOfVariableToMap |
	indexOfVariableToMap := notIgnoredVariables indexOf: sourceName.
	indexOfVariableToMap > 0
		ifTrue: [ mapping 
			at: indexOfVariableToMap 
			put: (theClass
				instVarIndexFor: destinationName
				ifAbsent: [self error: 'Bad variable destination.'])].
! !

!FLVariablesMapping methodsFor: 'serialize/materialize' stamp: 'MartinDias 5/11/2012 14:07'!
materializeReferencesOf: anObject with: aDecoder 

	mapping do: [ :index | 
			| reference |
			reference := aDecoder nextEncodedReference.
			index ifNotNil: [
				anObject 
					instVarAt: index
					put: reference ]].! !

!FLVariablesMapping methodsFor: 'analyzing' stamp: 'MartinDias 12/22/2011 15:08'!
referencesOf: anObject do: aBlock

	mapping do: [ :index | aBlock value: (anObject instVarAt: index) ].! !

!FLVariablesMapping methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 20:10'!
serializeOn: anEncoder

	anEncoder encodeByte: notIgnoredVariables size.	
	notIgnoredVariables do: [ :name | anEncoder encodeString: name ].! !

!FLVariablesMapping methodsFor: 'serialize/materialize' stamp: 'MartinDias 5/11/2012 14:08'!
serializeReferencesOf: anObject with: anEncoder 

	mapping do: [ :index | 
		anEncoder encodeReferenceTo: (anObject instVarAt: index) ].! !

Object subclass: #ManifestFuel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel'!

!ManifestFuel class methodsFor: 'meta data' stamp: 'MarianoMartinezPeck 4/21/2012 23:05'!
rejectClasses
^ #()! !

!ManifestFuel class methodsFor: 'meta data' stamp: 'MarianoMartinezPeck 4/21/2012 23:05'!
rejectRules
^ #()! !

!ManifestFuel class methodsFor: 'meta data' stamp: 'MarianoMartinezPeck 4/21/2012 17:20'!
ruleBadMessageRuleV1FalsePositive
^ #(#('(RGMethodDefinition className: ''FLVariablesMapping'' selector: #referencesOf:do: isMetaSide: false)' #'2012-04-21T17:20:38.668000001+02:00') #('(RGMethodDefinition className: ''FLVariablesMapping'' selector: #serializeReferencesOf:with: isMetaSide: false)' #'2012-04-21T17:20:38.680000001+02:00') #('(RGMethodDefinition className: ''FLVariablesMapping'' selector: #materializeReferencesOf:with: isMetaSide: false)' #'2012-04-21T17:20:38.697000001+02:00') #('(RGMethodDefinition className: ''FLBufferedWriteStream'' selector: #initializeStream: isMetaSide: false)' #'2012-04-21T17:20:38.750000001+02:00') )! !

!ManifestFuel class methodsFor: 'meta data' stamp: 'MarianoMartinezPeck 4/21/2012 17:26'!
ruleCodeCruftLeftInMethodsRuleV1FalsePositive
^ #(#('(RGMethodDefinition className: ''FLHookPrimitiveCluster'' selector: #registerIndexesOn: isMetaSide: false)' #'2012-04-21T17:26:41.076000001+02:00') #('(RGMethodDefinition className: ''FLPrimitiveCluster'' selector: #registerIndexesOn: isMetaSide: false)' #'2012-04-21T17:26:41.129000001+02:00') #('(RGMethodDefinition className: ''FLLightGeneralMapper'' selector: #visitCharacter: isMetaSide: false)' #'2012-04-21T17:26:41.178+02:00') #('(RGMethodDefinition className: ''FLBitsObjectCluster'' selector: #registerIndexesOn: isMetaSide: false)' #'2012-04-21T17:26:41.195000001+02:00') )! !

!ManifestFuel class methodsFor: 'meta data' stamp: 'MarianoMartinezPeck 4/21/2012 17:27'!
ruleConsistencyCheckRuleV1FalsePositive
^ #(#('(RGMethodDefinition className: ''Float'' selector: #serializeOn: isMetaSide: false)' #'2012-04-21T17:27:21.024000001+02:00') )! !

!ManifestFuel class methodsFor: 'meta data' stamp: 'MarianoMartinezPeck 4/21/2012 17:27'!
ruleContainsRuleV1FalsePositive
^ #(#('(RGMethodDefinition className: ''FLDecoder'' selector: #classNamed: isMetaSide: false)' #'2012-04-21T17:27:41.143000001+02:00') )! !

!ManifestFuel class methodsFor: 'meta data' stamp: 'MarianoMartinezPeck 4/21/2012 17:34'!
ruleInconsistentMethodClassificationRuleV1TruePositive
^ #(#('(RGMethodDefinition className: ''FLObjectCluster'' selector: #clusterReferencesDo: isMetaSide: false)' #'2012-04-20T23:31:50.298000001+02:00') #('(RGMethodDefinition className: ''FLCluster'' selector: #clusterReferencesDo: isMetaSide: false)' #'2012-04-20T23:31:50.314+02:00') #('(RGMethodDefinition className: ''FLMapper'' selector: #mapAndTrace: isMetaSide: false)' #'2012-04-20T23:31:50.331000001+02:00') #('(RGMethodDefinition className: ''FLLightGlobalMapper'' selector: #mapAndTrace: isMetaSide: false)' #'2012-04-20T23:31:50.347000001+02:00') #('(RGMethodDefinition className: ''FLAnalysis'' selector: #trace: isMetaSide: false)' #'2012-04-20T23:31:50.367+02:00') #('(RGMethodDefinition className: ''FLSerialization'' selector: #clusterInstancesStepOf: isMetaSide: false)' #'2012-04-21T17:34:52.402+02:00') #('(RGMethodDefinition className: ''FLSerialization'' selector: #headerStep isMetaSide: false)' #'2012-04-21T17:34:52.453000001+02:00') #('(RGMethodDefinition className: ''FLAnalysis'' selector: #run isMetaSide: false)' #'2012-04-21T17:34:52.470000001+02:00') )! !

!ManifestFuel class methodsFor: 'meta data' stamp: 'MarianoMartinezPeck 4/21/2012 17:36'!
ruleLawOfDemeterRuleV1FalsePositive
^ #(#('(RGMethodDefinition className: ''FLMethodNotFound class'' selector: #signalWith:and: isMetaSide: true)' #'2012-04-21T17:36:40.916000001+02:00') #('(RGMethodDefinition className: ''FLBadSignature class'' selector: #signalCurrentSignature:streamSignature: isMetaSide: true)' #'2012-04-21T17:36:40.942+02:00') #('(RGMethodDefinition className: ''FLMethodChanged class'' selector: #signalWith:and: isMetaSide: true)' #'2012-04-21T17:36:40.963000001+02:00') #('(RGMethodDefinition className: ''FLMaterializer'' selector: #verifySignatureFrom: isMetaSide: false)' #'2012-04-21T17:36:41.048000001+02:00') #('(RGMethodDefinition className: ''FLBadVersion class'' selector: #signalCurrentVersion:streamVersion: isMetaSide: true)' #'2012-04-21T17:36:41.098000001+02:00') #('(RGMethodDefinition className: ''FuelUtilities class'' selector: #cleanUpEverything isMetaSide: true)' #'2012-04-21T17:36:41.212000001+02:00') #('(RGMethodDefinition className: ''FuelUtilities class'' selector: #exportFuelBasic isMetaSide: true)' #'2012-04-21T17:36:41.245000001+02:00') #('(RGMethodDefinition className: ''FuelUtilities class'' selector: #exportFuelMooseExtensions isMetaSide: true)' #'2012-04-21T17:36:41.296000001+02:00') #('(RGMethodDefinition className: ''FLLightGlobalMapper class'' selector: #valuesFor: isMetaSide: true)' #'2012-04-21T17:36:41.34+02:00') #('(RGMethodDefinition className: ''FLBufferedWriteStream'' selector: #nextWordsPut: isMetaSide: false)' #'2012-04-21T17:36:41.463000001+02:00') #('(RGMethodDefinition className: ''PositionableStream'' selector: #fuelNextWordsInto: isMetaSide: false)' #'2012-04-21T17:36:41.504+02:00') #('(RGMethodDefinition className: ''WriteStream'' selector: #nextBytesPutAll: isMetaSide: false)' #'2012-04-21T17:36:41.782+02:00') #('(RGMethodDefinition className: ''BlockClosure'' selector: #isClean isMetaSide: false)' #'2012-04-21T17:36:41.83+02:00') #('(RGMethodDefinition className: ''BlockClosure'' selector: #abstractBytecodes isMetaSide: false)' #'2012-04-21T17:36:41.877+02:00') )! !

!ManifestFuel class methodsFor: 'meta data' stamp: 'MarianoMartinezPeck 4/21/2012 18:28'!
ruleSendsDifferentSuperRuleV1FalsePositive
^ #(#('(RGMethodDefinition className: ''ContextPart class'' selector: #newFromFrameSize: isMetaSide: true)' #'2012-04-21T18:26:23.807+02:00') #('(RGMethodDefinition className: ''WriteStream'' selector: #nextBytesPutAll: isMetaSide: false)' #'2012-04-21T18:28:27.666+02:00') )! !

!Object methodsFor: '*Fuel' stamp: 'MartinDias 3/29/2012 03:05'!
fuelAccept: aGeneralMapper

	"Be careful because the order is important. For example, weak are also variable, but we need that weak objects send #visitWeakObject: and not #visitVariableObject: "
	self class isFixed
		ifTrue: [ ^ aGeneralMapper visitFixedObject: self ].
	self class isWeak
		ifTrue: [ ^ aGeneralMapper visitWeakObject: self ].
	self class isPointers
		ifTrue: [ ^ aGeneralMapper visitVariableObject: self ].
	self class isBytes
		ifTrue: [ ^ aGeneralMapper visitBytesObject: self ].
	self class isWords
		ifTrue: [	^ aGeneralMapper visitWordsObject: self ].
	self error: 'Something is wrong!!'! !

!Object methodsFor: '*Fuel' stamp: 'MartinDias 8/27/2011 19:03'!
fuelAfterMaterialization
	"Materialization process will send this message after materializing instances of my class"! !
FLLargeIdentityHashedCollection initialize!
FLWellKnownObjectsCluster initialize!
